#
# Core
#
require 'pathname'

#
# Project
#
require 'metasploit'

# Namespace for all Metasploit Pro code.
module Metasploit::Pro
  class << self
    def load_modules(framework)
      # Initialize framework modules
      framework.init_module_paths

      $stdout.puts "[*] Loading the Professional modules..."

      module_pathname  = Metasploit::Pro.root.join('modules')
      module_path = module_pathname.to_s

      expected_modules = []

      Find.find(module_path) do |path|
        if path[/\.rb$/]
          expected_modules << path
        end
      end

      r = framework.modules.add_module_path(module_path)

      r.keys.sort.each do |k|
        $stdout.puts "\t#{r[k]} #{k} modules loaded"
      end
    end

    def root
      unless instance_variable_defined? :@root
        relative_directory = File.dirname(__FILE__)
        relative_pathname = Pathname.new(relative_directory)

        @root = relative_pathname.join('..', '..', '..').expand_path
      end

      @root
    end
  end
end
