module Metasploit::Pro::Engine
  class FlashPolicyServer
    #
    # CONSTANTS
    #

    DEFAULT_HOST = '127.0.0.1'
    DEFAULT_PORT = 843
    POLICY_FILE = %Q|<cross-domain-policy><allow-access-from domain="*" to-ports="*" /></cross-domain-policy>\x00|
    POLICY_FILE_REQUEST_REGEX = /<policy-file-request\/>\x00/

    attr_reader :host

    def initialize(attributes={})
      attributes.assert_valid_keys(:host, :port)

      @host = attributes[:host] || DEFAULT_HOST
      @port = attributes[:port] || DEFAULT_PORT
    end

    attr_reader :port

    def start
      @thread ||= Thread.new do
        run
      end
    end

    private

    def run
      $stdout.puts "[*] Starting Flash policy server (FPS) on #{host}:#{port}"

      server = TCPServer.new(host, port)

      while session = server.accept
        request = session.recv(23)

        $stdout.puts "[*] FPS: Got request: #{request}"

        if request.match expected
          session.print policy_file

          $stdout.puts '[*] FPS: Sent policy file.'
        else
          $stderr.puts '[-] FPS: Rejected request.'
        end

        session.close
      end
    end
  end
end