require 'metasploit/configured'
require 'metasploit/pro/ui/configuration'

module Metasploit::Pro::UI
  include Metasploit::Configured

  class << self
    def eager_load!(opts)
      super

      # want to eager load mdm models, but don't want to affect the $LOAD_PATH, so load manually here
      load_pathname = root.join('app', 'models')
      escaped_load_path = Regexp.escape(load_pathname.to_s)
      require_path_regex = /\A#{escaped_load_path}\/(.*)\.rb\Z/
      glob = root.join('app', 'models', 'mdm', '**', '*.rb')

      Dir.glob(glob) do |path|
        require_path = path.sub(require_path_regex, '\1')

        require_dependency require_path
      end
    end

    #
    # Fight the good fight against migration race conditions
    #
    def initialize_database
      db_initialized_pathname = root.join('tmp', 'db.initialized')

      if db_initialized_pathname.exist?
        db_initialized_pathname.delete
      end

      yield

      #
      # Write our flag to the initialized directory so thin can start up
      #
      db_initialized_pathname.open('wb') do |f|
        f.puts Process.pid
      end
    end

  end
end
