module Msf
module Pro
module Credentials

class AfpCreds < Builder
	SERVICE_LIMIT = 4000
	DEEP_FACTOR = 3

	def blank_usernames_allowed?
		false
	end

	def downcase_usernames?
		true
	end
	
end

class AfpKnownUserpassCreds < AfpCreds
	include KnownUtils
end

class AfpQuickCreds < AfpCreds
	include QuickUtils
end

class AfpCommonCreds < TelnetCommonCreds
end

class AfpImportedCreds < AfpCreds
	include ImportedUtils
end

class AfpRecombinedCreds < AfpCreds
	include RecombinedUtils
end

class AfpGuessedPasswordCreds < AfpCreds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class AfpGuessedUserpassCreds < AfpCreds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class AfpMutantCreds < AfpCreds
	include MutantPasswordUtils
end

end
end
end

