module Msf
module Pro
module Credentials

class Db2Creds < Builder
	SERVICE_LIMIT = 3000
	DEEP_FACTOR = 3

	def blank_usernames_allowed?
		false
	end

end

class Db2KnownUserpassCreds < Db2Creds
	include KnownUtils
end

class Db2QuickCreds < Db2Creds
	include QuickUtils
end

class Db2CommonCreds < Db2Creds
	include CommonUtils

	ONE_OFF_CREDENTIALS = [
		"db2cae2 db2cae"
	]

	def seed_with_these_creds?
		true
	end

	def create_common_users
		%w{db2inst1 dasusr1 db2fenc1 admin}
	end

	def create_common_passwords
		%w{db2pw db2password db2pass blank admin}
	end

end

class Db2ImportedCreds < Db2Creds
	include ImportedUtils
end

class Db2RecombinedCreds < Db2Creds
	include RecombinedUtils
end

class Db2GuessedPasswordCreds < Db2Creds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class Db2GuessedUserpassCreds < Db2Creds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class Db2MutantCreds < Db2Creds
	include MutantPasswordUtils
end

end
end
end

