module Msf
module Pro
module Credentials

class LoginCreds < Builder
	SERVICE_LIMIT = 1000
	DEEP_FACTOR = 1

	def blank_usernames_allowed?
		false
	end

end

class LoginKnownUserpassCreds < LoginCreds
	include KnownUtils
end

class LoginQuickCreds < LoginCreds
	include QuickUtils
end

class LoginCommonCreds < LoginCreds
	include CommonUtils
	include CommonShellUtils

	# Overrides CommonUtils since we want shell creds, too.
	# Also want to add in some special cisco creds.
	def create_common_creds
		users = create_common_users
		passes = []
		create_creds_from_users_and_passes(users,passes)
		common_shell_creds()
		wordlist_proto = [this_service,self.flavor].join("_")
		create_creds_from_protocol_wordlists(wordlist_proto)
	end

	def create_common_users
		%w{guest root user toor lp admin}
	end

	def create_common_passwords
		[]
	end
end

class LoginImportedCreds < LoginCreds
	include ImportedUtils
end

class LoginRecombinedCreds < LoginCreds
	include RecombinedUtils
end

class LoginGuessedPasswordCreds < LoginCreds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class LoginGuessedUserpassCreds < LoginCreds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class LoginMutantCreds < LoginCreds
	include MutantPasswordUtils
end

end
end
end

