module Msf
module Pro
module Credentials

class MssqlCreds < Builder
	SERVICE_LIMIT = 10_000
	DEEP_FACTOR = 3

	def blank_usernames_allowed?
		false
	end

end

class MssqlKnownUserpassCreds < MssqlCreds
	include KnownUtils
end

class MssqlQuickCreds < MssqlCreds
	include QuickUtils
end

class MssqlCommonCreds < MssqlCreds
	include CommonUtils

	ONE_OFF_CREDENTIALS = [
		"entldbdbo dbopswd",
		"ARAdmin AR#Admin#",
		"entldbreader rdrpswd",
		"WinCCConnect 2WSXcder"
	]

	def seed_with_these_creds?
		true
	end

	def create_common_users
		%w{sa mon_user probe repl_publisher repl_subscriber}
	end

	def create_common_passwords
		%w{blank pass password pass pass1}
	end

end

class MssqlImportedCreds < MssqlCreds
	include ImportedUtils
end

class MssqlRecombinedCreds < MssqlCreds
	include RecombinedUtils
end

class MssqlGuessedPasswordCreds < MssqlCreds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class MssqlGuessedUserpassCreds < MssqlCreds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class MssqlMutantCreds < MssqlCreds
	include MutantPasswordUtils
end

end
end
end

