module Msf
module Pro
module Credentials

class MysqlCreds < Builder
	SERVICE_LIMIT = 10_000
	DEEP_FACTOR = 3

	def blank_usernames_allowed?
		false
	end

end

class MysqlKnownUserpassCreds < MysqlCreds
	include KnownUtils
end

class MysqlQuickCreds < MysqlCreds
	include QuickUtils
end

class MysqlCommonCreds < MysqlCreds
	include CommonUtils

	ONE_OFF_CREDENTIALS = [
		"root vicidialnow"
	]

	def seed_with_these_creds?
		true
	end

	def create_common_users
		%w{root mysql admin}
	end

	def create_common_passwords
		%w{blank password pass pass1}
	end

end

class MysqlImportedCreds < MysqlCreds
	include ImportedUtils
end

class MysqlRecombinedCreds < MysqlCreds
	include RecombinedUtils
end

class MysqlGuessedPasswordCreds < MysqlCreds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class MysqlGuessedUserpassCreds < MysqlCreds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class MysqlMutantCreds < MysqlCreds
	include MutantPasswordUtils
end

end
end
end

