module Msf
module Pro
module Credentials

class OracleCreds < Builder
	SERVICE_LIMIT = 1000
	DEEP_FACTOR = 3

	def blank_usernames_allowed?
		false
	end

end

class OracleKnownUserpassCreds < OracleCreds
	include KnownUtils
end

class OracleQuickCreds < OracleCreds
	include QuickUtils
end

class OracleCommonCreds < OracleCreds
	include CommonUtils

	def seed_with_these_creds?
		true
	end

	def create_common_users
		%w{root admin ora system sys}
	end

	def create_common_passwords
		%w{blank password pass pass1}
	end

end

class OracleImportedCreds < OracleCreds
	include ImportedUtils
end

class OracleRecombinedCreds < OracleCreds
	include RecombinedUtils
end

class OracleGuessedPasswordCreds < OracleCreds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class OracleGuessedUserpassCreds < OracleCreds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class OracleMutantCreds < OracleCreds
	include MutantPasswordUtils
end

end
end
end

