module Msf
module Pro
module Credentials

class Pop3Creds < Builder
	SERVICE_LIMIT = 1000 # Testing shows a 2 second delay between each attempt.
	DEEP_FACTOR = 1

	# Are all pop3 servers case insensitive?
	def should_downcase_user?
		true
	end

	# Need an arugment to USER
	def blank_usernames_allowed?
		false
	end

	# Protocol doesn't require an argument to PASS
	def blank_passwords_allowed?
		true
	end

end

class Pop3KnownUserpassCreds < Pop3Creds
	include KnownUtils
end

class Pop3QuickCreds < Pop3Creds
	include QuickUtils
end

class Pop3CommonCreds < Pop3Creds
	include CommonUtils

	def seed_with_these_creds?
		true
	end

	def create_common_users
		%w{root user admin}
	end

	def create_common_passwords
		common_passwords
	end

end

class Pop3ImportedCreds < Pop3Creds
	include ImportedUtils
end

class Pop3RecombinedCreds < Pop3Creds
	include RecombinedUtils
end

class Pop3GuessedPasswordCreds < Pop3Creds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class Pop3GuessedUserpassCreds < Pop3Creds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class Pop3MutantCreds < Pop3Creds
	include MutantPasswordUtils
end

end
end
end

