module Msf
module Pro
module Credentials

class PostgresCreds < Builder
	SERVICE_LIMIT = 4000
	DEEP_FACTOR = 3

	def blank_usernames_allowed?
		false
	end

end

class PostgresKnownUserpassCreds < PostgresCreds
	include KnownUtils
end

class PostgresQuickCreds < PostgresCreds
	include QuickUtils
end

class PostgresCommonCreds < PostgresCreds
	include CommonUtils

	def seed_with_these_creds?
		true
	end

	def create_common_users
		%w{postgres root admin}
	end

	def create_common_passwords
		%w{blank password pass pass1}
	end

end

class PostgresImportedCreds < PostgresCreds
	include ImportedUtils
end

class PostgresRecombinedCreds < PostgresCreds
	include RecombinedUtils
end

class PostgresGuessedPasswordCreds < PostgresCreds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class PostgresGuessedUserpassCreds < PostgresCreds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class PostgresMutantCreds < PostgresCreds
	include MutantPasswordUtils
end

end
end
end

