module Msf
module Pro
module Credentials

class ShellCreds < Builder
	SERVICE_LIMIT = 1000
	DEEP_FACTOR = 1

	def blank_usernames_allowed?
		false
	end

	def just_usernames?
		true
	end

end

class ShellKnownUserpassCreds < ShellCreds
	include KnownUtils
end

class ShellQuickCreds < ShellCreds
	include QuickUtils
end

class ShellCommonCreds < ShellCreds
	include CommonUtils
	include CommonShellUtils

	# Overrides CommonUtils since we want shell creds, too.
	# Also want to add in some special cisco creds.
	def create_common_creds
		users = create_common_users
		passes = []
		create_creds_from_users_and_passes(users,passes)
		common_shell_creds()
		wordlist_proto = [this_service,self.flavor].join("_")
		create_creds_from_protocol_wordlists(wordlist_proto)
	end

	def create_common_users
		%w{guest root user toor lp admin}
	end

	def create_common_passwords
		[]
	end
end

class ShellImportedCreds < ShellCreds
	include ImportedUtils
end

class ShellRecombinedCreds < ShellCreds
	include RecombinedUtils
end

class ShellGuessedPasswordCreds < ShellCreds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class ShellGuessedUserpassCreds < ShellCreds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class ShellMutantCreds < ShellCreds
	include MutantPasswordUtils
end

end
end
end

