module Msf
module Pro
module Credentials

class SnmpCreds < Builder
	SERVICE_LIMIT = 1000

	def just_passwords?
		true
	end

end

class SnmpKnownUserpassCreds < SnmpCreds
	include KnownUtils
end

class SnmpQuickCreds < SnmpCreds
	include QuickUtils
end

class SnmpCommonCreds < SnmpCreds
	include CommonUtils

	def seed_with_these_creds?
		true
	end

	def create_common_users
		%w{root}
	end

	def create_common_passwords
		%w{blank password pass pass1}
	end

end

class SnmpImportedCreds < SnmpCreds
	include ImportedUtils
end

class SnmpRecombinedCreds < SnmpCreds
	include RecombinedUtils
end

class SnmpGuessedPasswordCreds < SnmpCreds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class SnmpGuessedUserpassCreds < SnmpCreds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class SnmpMutantCreds < SnmpCreds
	include MutantPasswordUtils
end

end
end
end

