module Msf
module Pro
module Credentials

# Based entirely off of Ssh creds. There is no difference at all.
# Factories should be smart about this kind of thing. Maybe
# peek at the ancestors to tell it's subclassed, or something?
class SshCreds < TelnetCreds
end

class SshKnownUserpassCreds < TelnetKnownUserpassCreds

	# Override find_workspace_creds to pick up users
	# with ssh_keys, too, and assign them a blank password
	# so we can test ssh_key logins as well.

	def find_workspace_creds
		self.workspace.creds.each do |cred| 
			next if should_skip? cred
			if cred.ptype == "ssh_key"
				this_cred = "#{cred.user} "
			elsif cred.ptype =~ /^password/
				this_cred = cred.pass ? [cred.user,cred.pass].join(" ") : cred.user
			else
				next
			end
			add_cred this_cred
		end
		self.creds
	end

end

class SshQuickCreds < TelnetQuickCreds
end

class SshCommonCreds < TelnetCommonCreds
end

class SshImportedCreds < TelnetImportedCreds
end

class SshRecombinedCreds < TelnetRecombinedCreds
end

class SshGuessedPasswordCreds < TelnetGuessedPasswordCreds
end

class SshGuessedUserpassCreds < TelnetGuessedUserpassCreds
end

class SshMutantCreds < TelnetMutantCreds
end

end
end
end

