module Msf
module Pro
module Credentials

class VmauthdCreds < Builder
	SERVICE_LIMIT = 4000
	DEEP_FACTOR = 3

	def blank_usernames_allowed?
		false
	end

	def downcase_usernames?
		true
	end
	
end

class VmauthdKnownUserpassCreds < VmauthdCreds
	include KnownUtils
end

class VmauthdQuickCreds < VmauthdCreds
	include QuickUtils
end

class VmauthdCommonCreds < VmauthdCreds
	include CommonUtils
	include CommonShellUtils


	def create_common_users
		%w{administrator admin backup}
	end

	def create_common_passwords
		common_passwords + %w{admin backup}
	end


end

class VmauthdImportedCreds < VmauthdCreds
	include ImportedUtils
end

class VmauthdRecombinedCreds < VmauthdCreds
	include RecombinedUtils
end

class VmauthdGuessedPasswordCreds < VmauthdCreds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class VmauthdGuessedUserpassCreds < VmauthdCreds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class VmauthdMutantCreds < VmauthdCreds
	include MutantPasswordUtils
end

end
end
end

