module Msf
module Pro
module Credentials

class VncCreds < Builder
	SERVICE_LIMIT = 1000
	DEEP_FACTOR = 1

	def just_passwords?
		true
	end

end

class VncKnownUserpassCreds < VncCreds
	include KnownUtils
end

class VncQuickCreds < VncCreds
	include QuickUtils
end

class VncCommonCreds < VncCreds
	include CommonUtils

	ONE_OFF_CREDENTIALS = [
		"root 100" # Seimen's default.
	]

	def seed_with_these_creds?
		true
	end

	def create_common_users
		%w{root}
	end

	def create_common_passwords
		%w{blank password pass pass1}
	end

end

class VncImportedCreds < VncCreds
	include ImportedUtils
end

class VncRecombinedCreds < VncCreds
	include RecombinedUtils
end

class VncGuessedPasswordCreds < VncCreds
	include UnixWordlistUtils
	include GuessedPasswordUtils
end

class VncGuessedUserpassCreds < VncCreds
	include UnixWordlistUtils
	include GuessedUserpassUtils
end

class VncMutantCreds < VncCreds
	include MutantPasswordUtils
end

end
end
end

