
module Pro
module ExeGen
class Pseudofunction

	FUNCTION_NAME_LENGTH = 18
	VAR_NAME_LENGTH            = 12

	def initialize(attributes={})
		@subroutines = attributes[:subs]  || []
		@name            = attributes[:name] || ::Rex::Text.rand_text_alpha(FUNCTION_NAME_LENGTH)
		@type              = random_type
		@params        = random_params
		@definition    = generate_definition
		@fcaller          = generate_fcaller
	end

	attr_accessor :subroutines
	attr_accessor :name
	attr_accessor :type
	attr_accessor :params
	attr_accessor :definition
	attr_accessor :fcaller


	def generate_fcaller
		pstrings =[]
		params.each{ |p| pstrings << "#{p[:value]}" }
		pstring = pstrings.join(',')
		retcall = "#{@name}(#{pstring});\n"
		return retcall
	end

	def generate_definition
		retdef = ""
		pstrings =[]
		@params.each{ |p| pstrings << "#{p[:type]} #{p[:name]} " }
		pstring = pstrings.join(',')
		retdef << "#{@type} #{@name}(#{pstring}){ \n"
		2.upto(8){|i| retdef << random_code }
		retdef << "\treturn #{@params[rand((@params.count -1))][:name]};\n"
		retdef << "}"
	end


	def random_code
		case rand(5)
		when 0..2
			return random_operation
		when 3
			retval = "\tfor (int i=0; i<#{(rand(500) +100)}; i++){\n"
			2.upto(10){|i| retval << "\t #{random_operation}" }
			retval << "\t}\n"
			return retval
		when 4
			var1 = @params[ rand((@params.count)) ][:name]
			var2 = @params[ rand((@params.count)) ][:name]
			retval = "\tif (#{var1} < #{var2}){\n"
			if @subroutines.empty?
				retval << "\t #{random_operation}" 
			else
				retval << "\t #{@subroutines[rand(@subroutines.count) ].fcaller}"
			end
			retval << "\t}\n"
			retval << "\telse if (#{var1} > #{var2}){\n"
			if @subroutines.empty?
				retval << "\t #{random_operation}" 
			else
				retval << "\t #{@subroutines[rand(@subroutines.count) ].fcaller}"
			end
			retval << "\t}\n"
			retval << "\telse{\n"
			retval << "\t #{random_operation}" 
			retval << "\t}\n"
		end
	end


	def random_operation
		var1 = @params[ rand((@params.count)) ][:name]
		var2 = @params[ rand((@params.count)) ][:name]
		var3 = @params[ rand((@params.count)) ][:name]
		op = "\t#{var3} = #{var1} #{random_operator} #{var2};\n"
	end

	def random_operator
		ops = ["+", "-", "*",  "&", "|", "^", "<<", ">>"]
		ops[ rand(8)]
	end


	def random_type
		types = [ "short", "int", "long"]
		types[ rand(3) ]
	end

	def random_params
		rparams =[]
		0.upto( (rand(4)+2) ){|i| rparams << generate_param}
		return rparams
	end

	def generate_param
		param = {
			:type  => random_type,
			:name  => ::Rex::Text.rand_text_alpha(VAR_NAME_LENGTH),
			:value => (rand(100) +1).to_s
		}
	end



end
end
end