require 'pro/exegen/base_generator'
require 'pro/exegen/service_generator'

module Pro
module Hooks
class DynamicExe
	require 'msf/core/exploit/exe'

	attr_accessor :framework
	
	def initialize(framework)
    	self.framework   = framework
    	Msf::Exploit::EXE.module_eval do
      		#include Pro::Hooks::DynamicExeMixin
 			def generate_payload_exe(opts = {})
 				if datastore['DynamicExe']
					exe = generate_payload_exe_dynamic(opts)
					return exe
				end
				return get_custom_exe if datastore.include? 'EXE::Custom'

				exe_init_options(opts)

				pl = opts[:code]
				pl ||= payload.encoded

				# Fall back to x86...
				if not opts[:arch] or opts[:arch].length < 1
					opts[:arch] = [ ARCH_X86 ]
				end
				# Ensure we have an array
				if not opts[:arch].kind_of? Array
					opts[:arch] = [ opts[:arch] ]
				end

				# Transform the PlatformList
				if (opts[:platform].kind_of? Msf::Module::PlatformList)
					opts[:platform] = opts[:platform].platforms
				end

				exe = Msf::Util::EXE.to_executable(framework, opts[:arch], opts[:platform], pl, opts)
				exe_post_generation(opts)
				exe
			end

			def generate_payload_exe_service(opts = {})
				if datastore['DynamicExe']
					exe = generate_payload_exe_service_dynamic(opts)
					return exe
				end
				return get_custom_exe if datastore.include? 'EXE::Custom'

				exe_init_options(opts)

				# NOTE: Only Windows is supported here.
				pl = opts[:code]
				pl ||= payload.encoded

				if opts[:arch] and opts[:arch] == ARCH_X64
					exe = Msf::Util::EXE.to_win64pe_service(framework, pl, opts)
				else
					exe = Msf::Util::EXE.to_win32pe_service(framework, pl, opts)
				end

				exe_post_generation(opts)
				exe
			end

			def generate_payload_exe_dynamic(opts = {})
				exegen = ::Pro::ExeGen::BaseGenerator.new(payload.encoded)
				return exegen.exe
			end

			def generate_payload_exe_service_dynamic(opts = {})
				exegen = ::Pro::ExeGen::ServiceGenerator.new(payload.encoded)
				return exegen.exe
			end
    	end
  	end
end


end
end

Pro::Hooks::Loader.add_hook( Pro::Hooks::DynamicExe )