module Msf
###
#
# This module provides shared methods for top-level Pro modules
#
###
module Pro
module Locations


	def pro_base_directory
		::File.expand_path(::File.join(::File.dirname(__FILE__), '..', '..', '..', '..'))
	end

	def pro_cred_files_directory
		::File.expand_path(::File.join(pro_base_directory, 'cred_files'))
	end

	def pro_data_directory
		::File.expand_path(::File.join(pro_base_directory, 'data'))
	end

	def pro_logs_directory
		::File.expand_path(::File.join(pro_base_directory, 'logs'))
	end

	def pro_ui_directory
		::File.expand_path(::File.join(pro_base_directory, 'ui'))
	end

	def pro_modules_directory
		::File.expand_path(::File.join(pro_base_directory, 'modules'))
	end

	def pro_scripts_directory
		::File.expand_path(::File.join(pro_base_directory, 'scripts'))
	end

	def pro_engine_directory
		::File.expand_path(::File.join(pro_base_directory, 'engine'))
	end

	def pro_loot_directory
		::File.expand_path(::File.join(pro_base_directory, 'loot'))
	end

	def pro_report_directory
		::File.expand_path(::File.join(pro_base_directory, 'reports'))
	end

	def pro_export_directory
		::File.expand_path(::File.join(pro_base_directory, 'export'))
	end

	def pro_install_directory
		::File.expand_path(::File.join(pro_base_directory, '..', '..'))
	end

	def pro_vulndex_directory
		::File.expand_path(::File.join(pro_data_directory, 'vulndex'))
	end

	def pro_java_directory
		::File.expand_path(::File.join(pro_base_directory, 'java'))
	end

	# Find the java executable. XXX: Figure out where ours will be
	def pro_java_executable
		ret = Rex::FileUtils.find_full_path("java") || Rex::FileUtils.find_full_path("java.exe")
		return ::File.expand_path(ret) if ret
	end

	# Hunt for Nmap within the installation directory, defaulting to
	# the system version as necessary
	def pro_nmap_executable
		path = ::File.join(pro_install_directory, 'nmap', 'nmap')
		return ::File.expand_path(path) if File.exists?(path)

		path = ::File.join(pro_install_directory, 'nmap', 'nmap.exe')
		return ::File.expand_path(path) if File.exists?(path)

		path = ::File.join(pro_install_directory, 'common', 'bin', 'nmap')
		return ::File.expand_path(path) if File.exists?(path)

		path = ::File.join(pro_install_directory, 'common', 'bin', 'nmap.exe')
		return ::File.expand_path(path) if File.exists?(path)

		ret = Rex::FileUtils.find_full_path("nmap") || Rex::FileUtils.find_full_path("nmap.exe")
		return ::File.expand_path(ret) if ret
		nil
	end

	# Hunt for the Nmap data paths within the installation directory, defaulting
	# to nil if none was found. In the case of nil, do not specify the data path
	def pro_nmap_datapath
		path = ::File.join(pro_install_directory, 'nmap', 'nmap-os-db')
		return ::File.expand_path(::File.dirname(path)) if File.exists?(path)

		path = ::File.join(pro_install_directory, 'common', 'share', 'nmap', 'nmap-os-db')
		return ::File.expand_path(::File.dirname(path)) if File.exists?(path)
		nil
	end

	# Return where the exe templates are stored
	def express_exe_template_directory
		::File.join(pro_data_directory, 'exe_templates')
	end

	def pro_exe_template_directory
		::File.join(pro_data_directory, 'exe_templates', 'pro')
	end

end
end
end

