class ReportMessageBuilder
  attr_reader :message

  def initialize
    @message = MailMessage.new
    @message.from_address = 'reports@pro.metasploit.com'
    @message.subject = '[metasploit] Generated Report'
    @message.body = 'Please see the attached reports'
  end

  def from(address)
    new_address = format(address) 
    if valid_address?(new_address)
      @message.from_address = new_address
    end
  end

  def add_to(address)
    new_address = format(address) 
    @message.add_recipient(new_address) if valid_address?(new_address)
  end

  def sendable?
    not @message.to_addresses.empty?
  end

  private

  def format(address)
    address.nil? ? '' : address.strip
  end

  def valid_address?(address)
    address.index('@')
  end
end
