#!/usr/bin/env ruby
#

require 'socket'
base = File.expand_path(File.join(File.dirname(__FILE__)))

# Windows
win_path = File.join(base, "scripts", "servicerun.bat")
lin_path = File.join(base, "scripts", "ctl.sh")
lin_path_old = File.join(base, "scripts", "old-ctl.sh")

win_path_ui = File.join(base, "..", "ui", "scripts", "servicerun.bat")
lin_path_ui = File.join(base, "..", "ui", "scripts", "ctl.sh")

if RUBY_PLATFORM =~ /linux/i
	$0 = "restarter"
	
	Process.setsid rescue nil

	# Use the old ctl.sh to stop it if its there. We delete it so we dont
	# try it again ever.
	if File.exist?(lin_path_old)
		system("#{lin_path_old} stop")
		File.unlink(lin_path_old) rescue nil
	else
		system("#{lin_path} stop")
	end
	system("#{lin_path_ui} stop")
	sleep(5)

	system("#{lin_path} start")
	system("#{lin_path_ui} start")
	exit(0)
else
	system("cmd.exe /c #{win_path} STOP")
	system("cmd.exe /c #{win_path_ui} STOP")

	sleep(10)

	# Forcefully kill any left-over Ruby processes that are not our own
	begin
		pids = ::IO.popen("tasklist").readlines.grep(/ruby/i).map{|x| x.split(/\s+/)[1].to_i }
		pids -= [$$]
		pids.each do |pid|
			system("taskkill /F /PID #{pid}")
		end
	rescue ::Exception => e
		$stdout.puts "[-] Exception while attempting to kill the process: #{e.to_s}"
	end

	sleep(1)

	system("cmd.exe /c #{win_path} START")
	system("cmd.exe /c #{win_path_ui} START")
	exit(0)
end


## Note the exit(0) calls above. This only apply in development, and requires pidof to work properly 
pid = `pidof prosvc`
Process.kill(9, pid.to_i)

# Restart prosvc
$stderr.puts "[*] Warning: the user interface must be restarted manually"
system("ruby", ::File.join(base, "prosvc.rb"), "-E", "production")

