jQueryInWindow ($) ->
  class @TabbedModalView extends Backbone.View
    # private vars
    _tabIdx: -1
    _opened: false

    initialize: ->
      @setMaxWidth 1000
      window.origConfirm ||= window.confirm

    events: {
      'click a.close': 'close',
      'click ul.tabs>li': 'tabClicked'
    }

    # setTabs accepts an array of hashes {name, class, checkbox(bool)}
    setTabs: (@_tabs) =>
      _.each @_tabs, (tab) -> 
        tab['class'] ||= ''
        tab['checkbox'] ||= false

    setButtons: (@_btns) =>
      _.each @_btns, (btn) ->
        btn['class'] ||= ''

    setDescription: (@description) =>
    setTitle: (@title) =>
    setMaxWidth: (@maxWidth) =>

    # layout resizes and repositions the modal   
    layout: =>
      # applies a max-width
      if @$modal.width() > @maxWidth
        @$modal.width(@maxWidth)
      # centers on the screen
      modalWidth = @$modal.width()
      screenWidth = $(window).width()
      @$modal.css('left', parseInt(($(window).width()-@$modal.width())/2)+'px')
      @$modal.css('top', parseInt(($(window).height()-@$modal.height())/2)+'px')
      $('ul.tabs>li:first-child', @el).addClass('first-child')

    # pre-parse the underscore template
    template: _.template($('#tabbed-modal').html())

    open: =>
      @render()
      @_opened = true
      @escEnabled = true
      $('body').css(overflow: 'hidden').height($(window).height())
      $(window).unbind('resize.tabbedModal')
      $(window).unbind('keyup.tabbedModal')
      $(window).bind('resize.tabbedModal', @layout)
      $(window).bind('keyup.tabbedModal', @escKeyHandler)
      @stubCustomConfirm()

    @escKeyHandler: (e) =>
      @close() if e.keyCode == 27 && @escEnabled

    close: (e) =>
      e.preventHandler() if e && e.preventHandler
      @$el.html('')
      @_opened = false
      @escEnabled = false
      $('body').css(overflow: 'auto').css(height: 'auto', overflow: 'inherit')
      $(window).unbind('resize.tabbedModal')
      $(window).unbind('keyup.tabbedModal')
      window.confirm = window.origConfirm
      # we never see the view again. goodbye!
      @undelegateEvents()

    stubCustomConfirm: ->
      window.confirm = =>
        if @opened
          @escEnabled = false
          _.delay (=> @escEnabled = true), 300
          origConfirm.apply(window, arguments)
        else
          origConfirm.apply(window, arguments)

    index: (idx) =>
      return @_tabIdx if typeof idx == 'undefined'
      return @_tabIdx if idx == @_tabIdx || idx < 0 || idx >= @_tabs.length
      $ul = $('ul.tabs', @el)
      $li = $('li', $ul).removeClass('selected').eq(idx).addClass('selected')
      $('div.content', @el).toggleClass('top-left-square', idx == 0)
      @_tabIdx = idx
      @_tabIdx

    tabClicked: (e) =>
      $li = $(e.currentTarget)
      @index($li.index())

    tabAt: (idx) =>
      $('ul.tabs li', @$modal).eq(idx)

    render: ->
      super
      @$el.html(@template(this))
      @$modal = $('.tabbed-modal', @$el)
      @layout()
      @index(0) if @_tabIdx < 0

    # returns collection of dom elements
    tabs: -> $('ul.tabs>li', @$modal)
    content: -> $('.padding>.content', @$modal)