jQuery ($) ->
  $ ->
    # Initialize the tag creation dialog.
    $tagDialog = $('#tag-dialog');
    $tagDialog.dialog
      title:     "Tag Hosts"
      width:     430
      height:    350
      buttons:
        "Tag": ->
          $('#tag-form').submit()

      autoOpen: false
      open: (e, ui) ->
        # Enable tokenized input for tag searching.
        tagSearchPath = $('#search-tags-path').html()
        tokenInputOptions =
          "theme": "facebook"
          "hintText": "Type in a tag name..."
          "searchingText": "Searching tags..."
          "allowCustomEntry": true
          "preventDuplicates": true

        # Enable and pre-populate (if necessary) the token input
        $tokenInput  = $('#new_host_tags')
        $checkedRows = $("table.list tbody tr td input[type='checkbox']").filter(':checked').parents('tr')

        # Don't reinitialize the input.
        unless $tokenInput.data('tokenInputObject')
          $tokenInput.tokenInput tagSearchPath, tokenInputOptions

        $tokenInput.tokenInput 'clear'

        # If only one host is selected, load up its tags so we can edit them.
        if $checkedRows.size() == 1
          $checkedRows
            .children('td')
            .find('.tag').each ->
              name = $(this).children('span.tag-name').html()
              id   = parseInt $(this).children('span.tag-id').html()
              $tokenInput.tokenInput "add", {name, id}
        e.preventDefault()

    # Open the tagging dialog when the tag button is clicked.
    $('span.button a:contains(Tag)').live 'click', (e) ->
      unless $(this).parent().hasClass 'disabled'
        $tagDialog.find('.error-container').html('')
        $tagDialog.dialog('open')
        $checkedHosts = $("table.list tbody tr td input[type='checkbox']").filter(':checked')
        if $checkedHosts.size() == 1
          $tagDialog.dialog 'option', 'title', 'Edit Tags'
        else
          $tagDialog.dialog 'option', 'title', 'Tag Hosts'
        # Make the help text appear.
        $('ul.token-input-list-facebook').click()
      e.preventDefault()

    # Submit the tagging data when the dialog button is clicked.
    $('#tag-form').submit (e) ->
      action = $(this).attr('action')
      $.ajax
        url  : action,
        type : 'POST',
        data : $('#tag-form, #table-form').serialize(),
        success : ->
          $tagDialog.dialog('close')
          $('table.list').data('dataTableObject').fnDraw()
          $("table.list thead tr th input[type='checkbox']").attr('checked', false)
          #$('#flash_messages').html "<div class='flash notice'>#{result.responseText}"
        error: (result) ->
          $('.error-container').html "<div class='flash errors'>#{result.responseText}</div>"

      e.preventDefault()
      return false

    # Pull the host_ids checkboxes into the form before it is submitted.
    # $('#tag-form').submit (e) ->
    #   $(this).find('div#host-ids').remove()
    #   $(this).append('<div class="invisible" id="host-ids"></div>')
    #   log $('table.sortable tbody tr td:nth-child(1) input[type=checkbox].hosts') 
    #   $('table.sortable tbody tr td:nth-child(1) input[type=checkbox].hosts').clone().appendTo($(this).find('#host-ids'))

    # Change the tagging icon based on the number of checkboxes selected.
    $("table.sortable tbody tr td input[type='checkbox'].hosts").live 'change', ->
      $tagButton = $('span.button a:contains(Tag)')
      numChecked = $("table.sortable tbody tr td input[type='checkbox'].hosts").
        filter(':checked').size()
      switch numChecked
        when 0
          $tagButton.removeClass 'tag-edit tag-add'
          $tagButton.addClass    'tag-edit'
        when 1
          $tagButton.removeClass 'tag-edit tag-add'
          $tagButton.addClass    'tag-edit'
        else
          $tagButton.removeClass 'tag-edit tag-add'
          $tagButton.addClass    'tag-add'

          
      