# polls to update the task log, cancels polling when something
# matching $('.end') appears in the logs
jQuery ($) ->
  $ ->
    $(document).ready ->
      $log = $('#task_logs')
      task = $log.attr('task')
      window.log = $log
      $log.bind 'scrollToBottom', ->
        $(this).scrollTop $(this).attr('scrollHeight')

      $log.bind 'addLine', (event, html) ->
        prevLine = $(this).data('prevLine')
        # continue scrolling only if user is at the bottom
        padding = parseInt($(this).css('padding-top')) + parseInt($(this).css('padding-bottom'))
        innerHeight = $(this).attr('scrollHeight') - padding
        scrolled = $(this).height() + $(this).scrollTop()
        shouldScrollToBottom = (scrolled >= innerHeight)
        # append log contents
        $(this).append(html) if html != prevLine
        $(this).trigger('scrollToBottom') if shouldScrollToBottom
        $(this).data('prevLine', html)

      updateLog = ->
        if $('#task_logs .end').length == 0
          lines = $log.children().length
          $.getJSON '/tasks/' + task + '/logs?line=' + lines, (data) ->
            log = data['log']
            header = data['header']
            $('#task_logs').trigger('addLine', log) if log && log.length > 0
            $('#taskDetails').html(header) if header && header.length > 0
            window.setTimeout(updateLog, 3000) # once received, try again in 3s
 
      $log.trigger 'scrollToBottom'
      updateLog() # start polling
