_.templateSettings = {
  evaluate: /\{%([\s\S]+?)%\}/g,
  escape: /\{\{([\s\S]+?)\}\}/g
}

jQuery ($) ->
  toggleNewsPane = (e) ->
    # disable click to prevent rapid clicking from screwing things up
    $a = $(e.target).unbind('click')
    # add animation effect
    Effect.toggle('product-news', 'blind', {duration:0.2})
    # show/hide news feed and replace title and save choice in cookie
    if (document.getElementById('project-list').style.width == "60%") # show
      $a.html $a.html().replace('Hide', 'Show')
      $('#project-list').css 'width', '100%'

      document.cookie = 'ui-workspace-index-hide-product-news=false'
    else # hide
      $a.html $a.html().replace('Show', 'Hide')
      $('#project-list').css 'width', '60%'
      document.cookie = 'ui-workspace-index-hide-product-news=true'
    # reenable clicks after animation
    window.setTimeout (-> $a.bind('click', toggleNewsPane)), 300
    return false

  $(document).ready ->
    $("#all_workspaces").checkAll($("#workspace_checkboxes"))
    # load in product news through script tag
    script = document.createElement("script")
    pid = encodeURIComponent $('meta[name=msp-feed-serial]').attr('content')
    feedVersion = encodeURIComponent $('meta[name=msp-feed-serial]').attr('content')
    feedTs = encodeURIComponent $('meta[name=msp-feed-serial]').attr('content')
    script.setAttribute("src", "https://dev.metasploit.com/news.js?pid="+pid+"&ver="+feedVersion+"&ts="+feedTs);
    $(script).load ->
      buildFeedItem = (item) ->
        content = "<div class='feeditem'><h3><a href='#{item.link}' target='_blank'>#{item.title}</a></h3><p class='blurb'>#{item.blurb}</p></div>"
        $("#product-news-content").append content
      if !window.NEWSFEED || window.NEWSFEED.feed.items.length is 0
        $("#product-news-content").html 'Unable to retrieve the product news from the server.'
      else 
        $("#product-news-content").html ''
        buildFeedItem(item) for item in NEWSFEED.feed.items
    document.body.appendChild(script)

    # Add the show/hide news feed link, default to show
    newsHidden = document.cookie.match(/ui-workspace-index-hide-product-news=false/)
    currTitle = if newsHidden then 'Show News Panel' else 'Hide News Panel'
    $('#crumbHolder').append('<a style="float: right; background-image:none;' +
        ' padding-right: 16px; cursor: pointer;" class="showhide"' +
        ' href="#">'+currTitle+'</a>')
    $('#crumbHolder a.showhide').prepend('<img alt="Newspaper" ' +
        ' src="/assets/icons/silky/newspaper.png" style="margin-bottom: -3px; ' +
        ' margin-right: 3px;">').click(toggleNewsPane)

    # Modules table should be sortable and searchable.
    $("#workspace-table").table
      searchable:         false
      datatableOptions:
        "aaSorting":      [[7, 'desc']]
        "aoColumns": [
          {"bSortable": false}
          {}
          {}
          {}
          {}
          {}
          {}
          { "sType":        "title-numeric" }
          {}
        ]

    # Add an input hint to the search input
    $('#search').inputHint
      fadeOutSpeed: 300
      padding: '2px'
      paddingLeft: '5px'

    # show / hide product news based on cookie
    if newsHidden
      $("#product-news").hide()
      $('#project-list').css 'width', '100%'
    else
      $("#product-news").show()
      $('#project-list').css 'width', '60%'