
class EmailTemplatesController < ApplicationController
	before_filter :load_workspace

	def index
		@masters = EmailTemplate.where(:parent_id => nil).order("name")
	end

	def new
		@email_template = EmailTemplate.new
	end

	def edit
		if (params[:id])
			@email_template = EmailTemplate.find(params[:id], :include => :attachments)

			# Work around a rails 2.3.5 bug
			# http://ryanbigg.com/2010/04/has_and_belongs_to_many-double-insert/
			@email_template.attachments.uniq!
		else
			@email_template = EmailTemplate.new
		end
	end

	def update
		@email_template = EmailTemplate.find(params[:id])

		# If any files were uploaded, read out their contents to be used as the
		# attachment data.
		if params[:email_template][:attachments_attributes]
			params[:email_template][:attachments_attributes].each do |idx,attach_attrs|
				if attach_attrs[:data]
					if attach_attrs[:content_type].blank? 
						attach_attrs[:content_type] = attach_attrs[:data].content_type
					end
					data = attach_attrs[:data].read
					attach_attrs[:data] = data
				end
			end
		end

		@email_template.update_attributes(params[:email_template])
		@email_template.save
		if @email_template.save
			flash[:notice] = "Email template updated"
		else
			flash[:error] = "Email template not saved. Error: #{h(@email_template.error)}"
		end

		redirect_to workspace_campaign_url(@workspace, @email_template.campaign)
	end

	def create
		@email_template = EmailTemplate.new(params[:email_template])

		if @email_template.save!
			flash[:notice] = "Email template created"
			redirect_to workspace_email_templates_url(@workspace)
		else
			render :action => 'edit'
		end
	end

end

