module SocialEngineering
class WebServerConfigController < ServerConfigController
  CUSTOM_HOST_VALUE_PLACEHOLDER = 'custom_value'

  def edit
    compute_hosts
  end

  def update
    @campaign.web_host = params[:social_engineering_campaign][:web_host]
    @campaign.web_port = params[:social_engineering_campaign][:web_port]
    @campaign.web_bap_port = params[:social_engineering_campaign][:web_bap_port]
    @campaign.web_ssl  = (params[:social_engineering_campaign][:web_ssl].to_i == 1)
    @campaign.web_ssl_use_custom_cert = (params[:social_engineering_campaign][:web_ssl_use_custom_cert].to_i == 1)
    @campaign.web_ssl_cert = params[:social_engineering_campaign][:web_ssl_cert]


    @campaign.errors.clear
    if @campaign.save
      render :json => SocialEngineering::CampaignSummary.new(@campaign).to_json
    else
      # TODO: rationalize handling of failure condition
      compute_hosts
      render :edit, :status => :error
    end
  end

  private

  def compute_hosts
    @default_ip = Rex::Socket.source_address()
    @default_host = Socket.gethostname
    if [@default_ip, @default_host].include? @campaign.web_host
      @other_value = ''
    else
      @other_value = @campaign.web_host
      # in order for formtastic to select the correct radio button
      @campaign.web_host = CUSTOM_HOST_VALUE_PLACEHOLDER
    end
  end

end
end
