module ModulesHelper

	def module_type_html(m)
		case m.type
		when 'exploit'
			rank = module_star_icons(m.rank.to_i)
			stance = (m.stance == "aggressive") ? "Server" : "Client"
			( content_tag :h3, "#{stance} Application Exploit #{rank}" ).html_safe
		when 'auxiliary'
			stance = (m.stance == "aggressive") ? "Server" : "Client"
			( content_tag :h3, "#{stance} Application Utility" ).html_safe
		else
			''
		end
	end

	def module_icons_html(m)
		icos = m.platform.map{ |x| os_to_icon(x) }
		icos += m.targets.map{ |x| os_to_icon(x) } if m.targets
		icos += m.actions.map{ |x| os_to_icon(x) } if m.actions

		if icos.empty?
			icos << os_to_icon(m.description)
		end

		icos.uniq!

		("<span title='#{icos.size}'></span>" + icos.map { |path| image_tag path, :size => "19x18" }.join(' ')).html_safe
	end

	def module_star_icons(rank)
		stars  = [(rank - 100), 0].max / 100
		( (image_tag 'icons/star.png') * stars ).html_safe
	end

	def description_to_html(desc)
		ps = desc.split("\n\n")
		ps.map{ |p| content_tag(:p, h(p)) }.join("\n").html_safe
	end

end
