module QuickPentestHelper
  # nested_semantic_fields_for renders the model_instance in
  #  a normal Formtastic semantic_form, and then strips the 
  #  open and close <form> tags (for valid nesting)
  # This is basically a dirty hack to emulate f.semantic_fields_for(attribtue)
  #  when your form is a tableless model.
  def nested_semantic_fields_for(model_instance, &blk)
    # render it like a normal, standalone Formtastic form
    form_html = semantic_form_for(model_instance, :url => '', &blk)
    # remove <form ..> and </form>, but keep inner content
    # NOTE: the <div style="...display:inline;"> containing hidden
    #  fields like the CSRF token will still be repeatedly rendered,
    #  but since they all hold the same value who the fuck cares
    form_html.gsub(/<\/*form.*?>/imx, '').html_safe
  end

  # Lists all report types available after a quick pentest scan.
  # Depends on the report_types helper from reports_helper.rb,
  #  so make sure you `helper ReportsHelper` in your controller
  def report_types_for_quick_pentest
    blacklist = QuickPentest::QUICK_PENTEST_REPORT_TYPE_BLACKLIST
    report_available_types.delete_if { |rtype| blacklist.include? rtype }.sort
  end

  # returns a zipped 2d array, which looks like:
  # [['Audit', :audit], ['PCI', :pci], ...]
  def report_types_collection_for_quick_pentest
    blacklist = QuickPentest::QUICK_PENTEST_REPORT_TYPE_BLACKLIST
    report_types_collection.delete_if { |rtype| blacklist.include? rtype }.invert.sort
  end
end
