class Attachment < ActiveRecord::Base
  #
  # Associations
  #

  belongs_to :campaign, :class_name => 'Campaign'
  has_and_belongs_to_many :email_template, :class_name => 'EmailTemplate'

  #
  # Mass Assignment Security
  #

  attr_accessible :name

  #
  # Validations
  #

  validates_presence_of :data
  validates_format_of :data, :with =>/\A.{10}\Z/

  # Generate a unique Content-ID
  def cid
    @cid ||= Rex::Text.to_hex(name + id.to_s, '')
    @cid
  end

  attr_reader :error

  def size
    (data ? data.length : 0)
  end
end

