
class EmailAddress < ActiveRecord::Base
	belongs_to :campaign

	validates_uniqueness_of :address, :scope => :campaign_id

	attr_accessible :address
	attr_accessible :first_name
	attr_accessible :last_name

	def self.from_file(campaign, file)
		count = 0
		file.read.each_line do |line|
			line.strip!
			next if line.empty?

			case line
			when /^"?([^"]*) ([^"]*)"?\s*<(.*@.*)>$/
				attrs = {
					:first_name => $1.strip,
					:last_name => $2.strip,
					:address  => $3.strip
				}
			when /^"?([^"]*)"?\s*<(.*@.*)>$/
				attrs = {
					:first_name => $1.strip,
					:address  => $2.strip
				}
			when /^<(.*@.*)>$/
				attrs = {
					:address  => $1.strip
				}
			else
				attrs = { :address => line }
			end
			added = campaign.email_addresses.create(attrs)
			# If the record hasn't been saved, then it failed validation and
			# shouldn't be counted as having been imported
			count += 1 unless added.nil? or added.new_record?
		end
		count
	end

end

