
class GenerateExeTask < TaskConfig
	attr_accessor :campaign

	def initialize(attributes)
		super(attributes)
		@campaign = attributes[:campaign]
		@username = attributes[:username]
		@lport = attributes[:lport].to_i
		@lhost = attributes[:lhost]
		@fname = attributes[:filename]
		@ptype = attributes[:ptype]
	end

	def valid?
		unless @lhost =~ /^\d+\.\d+\.\d+\.\d+$/
			@error = "Invalid LHOST"
			return false
		end
		unless @lport <= 65535 and @lport >= 1
			@error = "Invalid LPORT"
			return false
		end
		@error = nil
		return true
	end

	def rpc_call
		client.generate_exe({
			'workspace' => @workspace.name,
			'username'  => @username,
			'DS_CAMPAIGN_ID' => @campaign.id,
			'DS_LHOST' => @lhost,
			'DS_LPORT' => @lport,
			'DS_FILENAME' => @fname,
		})
	end

end

