class SocialEngineering::TargetListHumanTarget < ActiveRecord::Base
  self.table_name = :se_target_list_human_targets

  #
  # Associations
  #

  belongs_to :human_target, :class_name => 'SocialEngineering::HumanTarget'
  belongs_to :target_list, :class_name => 'SocialEngineering::TargetList'

  #
  # Mass Assignment Security
  #

  # User is NOT allowed to set timestamps, created_at or updated_at
  # User is allowed to set human_target_id to associate the HumanTarget with the TargetList
  attr_accessible :human_target_id
  # User is allowed to set target_list_id to add the HumanTarget to the TargetList
  attr_accessible :target_list_id
end
