class UpdateCheck

	attr :current_version
	attr :version
	attr :info
	attr :error

	def initialize(params = {})
		@proxy_params = params
		c = Pro::Client.get
		r = c.call("pro.update_available", @proxy_params)
		if (r["status"] == "success")
			@current_version = r['current']
			@version = r['version']
			@info    = r['info']
		else
			@error = r["reason"]
			@error = nil if @error == ""
		end
	end

	def up_to_date?
		# @version == "0" means no updates are available from the server
		version.to_s == "0" or current_version.to_s == version.to_s
	end

	def apply
		c = Pro::Client.get
		r = c.call("pro.update_install", @proxy_params.merge({"version" => version}))
		if (r["result"] == "failed")
			@error = r["reason"]
			return false
		else
			@error = nil
			return true
		end
	end

end

