class WebTemplate < ActiveRecord::Base
  belongs_to :campaign, :class_name => "::Campaign"
  extend MetasploitDataModels::SerializedPrefs
  serialize :prefs, MetasploitDataModels::Base64Serializer.new

  serialized_prefs_attr_accessor :exploit_type
  serialized_prefs_attr_accessor :exploit_name, :exploit_opts
  after_initialize :set_defaults

  attr_accessible :campaign_id
  attr_accessible :exploit_name
  attr_accessible :exploit_opts
  attr_accessible :exploit_type
  attr_accessible :name 
  attr_accessible :prefs
  attr_accessible :started_at
  attr_accessible :status
  
	# if this template has no campaign associated with it, then it is a master
	# template
	def master?
		campaign_id.nil?
	end

	def set_defaults
		#return unless self.new_record?
		self.exploit_type = "autopwn" unless self.exploit_type
		self.exploit_opts = {} unless self.exploit_opts
	end

	def exploit_module
		MsfModule.find_by_fullname(exploit_name)
	end
	
	def exploit_opts
    prefs[:exploit_opts] || {}
  end
end

