Pro::Application.configure do
  # Settings specified here will take precedence over those in config/application.rb

  # Disable caching
  config.action_controller.perform_caching = false

  # Only use best-standards-support built into browsers
  config.action_dispatch.best_standards_support = :builtin

  # Raise ActionMailer errors while developing
  config.action_mailer.raise_delivery_errors = true

  # Log the query plan for queries taking more than this (works
  # with SQLite, MySQL, and PostgreSQL)
  config.active_record.auto_explain_threshold_in_seconds = 0.5
  # Raise exception on mass assignment protection for Active Record models
  config.active_record.mass_assignment_sanitizer = :strict

   # Print deprecation notices to the Rails logger
  config.active_support.deprecation = :log

  # Do not compress assets
  config.assets.compress = false
  # Expands the lines which load the assets
  config.assets.debug = true
  # Precompile additional assets (application.js, application.css, and all non-JS/CSS are already added)
  config.assets.precompile += ['*.js', '**/*.js', "*.css", "**/*.css"]

  # In the development environment your application's code is reloaded on
  # every request.  This slows down response time but is perfect for development
  # since you don't have to restart the web server when you make code changes.
  config.cache_classes = false

  # Show full error reports
  config.consider_all_requests_local = true

  # Prevent public/assets folder from being served
  config.serve_static_assets = false

  # Log error messages when you accidentally call methods on nil.
  config.whiny_nils = true
end

# Feature flag for "new style" social engineering
FF_SOCIAL_ENGINEERING = true
# Feature flag for the new branding
FF_NEW_BRANDING = true
# Feature flag for Quick Start Menu
FF_QUICK_START_MENU = true
# Feature flag for anything to do w/ WebScan (crawl, audit, exploit)
# that isn't supposed to be available until GA.
FF_ARTHAS_WEBSCAN = true
