Pro::Application.configure do
  # Settings specified here will take precedence over those in config/application.rb

  # Caching is turned on
  config.action_controller.perform_caching = true

  # Specifies the header that your server uses for sending files
  # config.action_dispatch.x_sendfile_header = "X-Sendfile" # for apache
  config.action_dispatch.x_sendfile_header = 'X-Accel-Redirect' # for nginx

   # Send deprecation notices to registered listeners
  config.active_support.deprecation = :notify

  # Don't fallback to assets pipeline if a precompiled asset is missed
  config.assets.compile = false
  # Compress JavaScripts and CSS
  # set to false to avoid minification error
  config.assets.compress = false
  # Generate digests for assets URLs
  config.assets.digest = true
  # Precompile additional assets (application.js, application.css, and all non-JS/CSS are already added)
  config.assets.precompile += ['*.js', '**/*.js', "*.css", "**/*.css"]

  # Code is not reloaded between requests
  config.cache_classes = true

  # Full error reports are disabled
  config.consider_all_requests_local = false

  # Enable locale fallbacks for I18n (makes lookups for any locale fall back to
  # the I18n.default_locale when a translation can not be found)
  config.i18n.fallbacks = true

  # See everything in the log (default is :info)
  config.log_level = :warn

  # Disable Rails's static asset server (Apache or nginx will already do this)
  config.serve_static_assets = true
end

# Feature flag for "new style" social engineering
FF_SOCIAL_ENGINEERING = true
# Feature flag for the new branding
FF_NEW_BRANDING = false
# Feature flag for Quick Start Menu
FF_QUICK_START_MENU = false
# Feature flag for anything to do w/ WebScan (crawl, audit, exploit)
# that isn't supposed to be available until GA.
FF_ARTHAS_WEBSCAN = false
