root = Rails.root

unless root
  root = Metasploit::Pro::UI.root
end

lib_pathname = root.join('lib')
mdm_concerns_pathname = lib_pathname.join('mdm')

mdm_concerns_pathname.each_child do |child_pathname|
  underscored_model_name = child_pathname.basename
  on_load_name = "mdm_#{underscored_model_name}".to_sym

  ActiveSupport.on_load(on_load_name) do
    Metasploit::Pro::Loading.each_pathname_constant(
        child_pathname,
        :relative_to => lib_pathname
    ) do |concern|
      include concern
    end

    if Rails.env.development?
      unloadable
    end
  end
end
