# @note This migration does not handle moving the data because it is assumed to be done when there is no data to migrate
class SwapWebRequestsReferencesVulnerabilityWithWebVulnsReferencesRequest < ActiveRecord::Migration
  def up
    change_table :web_requests do |t|
      t.remove_references :vulnerability
    end

    # Let both web_site_id and request_id be null as either or the other needs to be set, which is guaranteed by
    # Rails validators

    change_column_null(:web_vulns, :web_site_id, true)

    change_table :web_vulns do |t|
      t.references :request, :null => true
    end
  end

  def down
    change_table :web_vulns do |t|
      t.remove_references :request
    end

    change_column_null(:web_vulns, :web_site_id, false)

    change_table :web_requests do |t|
      t.references :vulnerability, :null => false
    end
  end
end
