module Mdm::Workspace::ReportTemplates
  #
  # CONSTANTS
  #

  REPORT_TEMPLATE_JASPER_EXTENSIONS = [
      '.jasper',
      '.jrxml'
  ]

  #
  # Instance Methods
  #

  def report_templates_jasper
    report_templates.where(report_templates_jasper_where)
  end

  def report_templates_logos
    report_templates.where(report_templates_jasper_where.not)
  end

  private

  def report_templates_jasper_where
    report_templates_reflection = self.class.reflect_on_association(:report_templates)
    report_templates_class = report_templates_reflection.klass
    report_templates_table = report_templates_class.arel_table

    likes = REPORT_TEMPLATE_JASPER_EXTENSIONS.collect { |extension|
      "%#{extension}"
    }

    report_templates_table[:path].matches_any(likes)
  end
end