# QuickPentest "faux" model for rendering the QuickPentest form.
# The idea behind the QuickPentest widget is to allow our sales guys
#   to launch Pro, click one button, enter an IP and immediately pwn
#   everything, so we need some really badass defaults.
class QuickPentest < Custom::FormtasticFauxModel
  include Metasploit::Pro::AttrAccessor::Boolean
  # possible options for the scanning phase
  QUICK_PENTEST_SCAN_TYPES_FORMATTED = [
    ["Regular Scan", :regular_scan],
    ["Nexpose Scan", :nexpose_scan],
    ["Import", :import]
  ]

  # disallow these report types since they don't apply when
  #  kicking off a quick pentest scan
  QUICK_PENTEST_REPORT_TYPE_BLACKLIST = [
    :campaigns, :se_campaign_detail, :custom, :webapp
  ]

  # nested models
  attr_accessor :exploit_task
  attr_accessor :import_task
  attr_accessor :nexpose_task
  attr_accessor :report_task
  attr_accessor :scan_task
  attr_accessor :workspace

  # "glue" attributes that don't belong to any nested model
  attr_accessor :collect_evidence
  attr_accessor :exploit_enabled
  attr_accessor :report_enabled
  attr_accessor :report_type   # used ONLY to render form :)
  attr_accessor :scan_type

  def initialize(attrs={})
    attrs.each do |key, val|
      send("#{key}=", val)
    end

    self.collect_evidence = set_default_boolean(collect_evidence, false)
    self.report_enabled = set_default_boolean(report_enabled, false)
    self.exploit_enabled = set_default_boolean(exploit_enabled, false)
  end
end