module SocialEngineering::WebPage::AttackType::Exploit
  extend ActiveSupport::Concern

  #
  # CONSTANTS
  #

  EXPLOIT_ATTACK_TYPES = ['bap', 'exploit', 'signed_java_applet']

  included do
    extend MetasploitDataModels::SerializedPrefs

    #
    # Mass Assignment Security
    #

    attr_accessible :exploit_module_config
    attr_accessible :exploit_module_path

    #
    # Serialized Preferences
    #

    serialized_prefs_attr_accessor :exploit_module_config
    serialized_prefs_attr_accessor :exploit_module_path

    #
    # Validations
    #

    validates :exploit_module_config, :presence => true, :if => :exploit_attack?
    validates :exploit_module_config, :presence => true, :if => :file_format_attack?
    validates :exploit_module_path, :presence => true, :if => :exploit_attack?
    validates :exploit_module_path, :presence => true, :if => :file_format_attack?
  end

    #
  # Instance Methods - sorted by name
  #

  def exploit_attack?
    EXPLOIT_ATTACK_TYPES.include?(attack_type) || file_format_attack?
  end

  # returns the MsfModule
  def exploit_module
    if exploit_attack?
      MsfModule.find_by_fullname exploit_module_path
    end
  end
end