module Web::RequestEngine::Parts
  def models_pathname
    Rails.root.join('app', 'models')
  end

  def part_class_names(type)
    part_class_set_by_type[type].map(&:name)
  end

  def part_class_set_by_type
    @part_class_set_by_type ||= Hash.new { |hash, type|
      hash[type] = Set.new
    }
  end

  def parts_pathname
    models_pathname.join('web', 'request_engine')
  end

  def uses(pluralized_type)
    singular_type = pluralized_type.to_s.singularize.to_sym
    type_directory = singular_type.to_s
    type_pathname = parts_pathname.join(type_directory)

    Metasploit::Pro::Loading.each_pathname_constant(type_pathname, :relative_to => models_pathname) do |klass|
      part_class_set_by_type[singular_type].add klass
    end
  end
end