(function() {

  jQuery(function($) {
    var Forms, HelpLinks;
    Forms = {
      autoFocus: function() {
        return $('form.formtastic input:visible, form.formtastic textarea:visible').first().focus();
      },
      disableSubmit: function() {
        var $form;
        $form = $('form.formtastic');
        $form.find('input[type=submit]').click(function() {
          return $(this).addClass('submitting').addClass('disabled');
        });
        return $form.bind("formSubmitted", function() {
          log('hello');
          return $form.find('input[type=submit]').removeClass('submitting').removeClass('disabled');
        });
      },
      bind: function() {
        this.autoFocus();
        this.disableSubmit();
        return $('body').prepend('<img src="/assets/spinner.gif" class="invisible" />');
      }
    };
    HelpLinks = {
      helpDivSelector: function(fieldKey) {
        return ".inline-help[data-field=" + fieldKey + "]";
      }
    };
    return $(document).ready(function() {
      $('a#advanced-options').live('click', function(e) {
        if ($(this).hasClass('show-advanced-options')) {
          $(this).html("Hide Advanced Options");
          $(this).removeClass('show-advanced-options');
          $(this).addClass('hide-advanced-options');
          $('.advanced').slideDown('fast');
        } else {
          $(this).html("Show Advanced Options");
          $(this).removeClass('hide-advanced-options');
          $(this).addClass('show-advanced-options');
          $('.advanced').slideUp('fast');
        }
        e.stopImmediatePropagation();
        return e.preventDefault();
      });
      $('.inline-help').each(function() {
        var $helpLink, $newHelpLink, $targetLi;
        $helpLink = $(this).children('a');
        $targetLi = $("#" + ($helpLink.data('field')));
        $targetLi.append($helpLink.clone());
        $newHelpLink = $targetLi.children('a');
        return $helpLink.remove();
      });
      $('a.help').mouseover(function() {
        var $helpDiv, pos, width;
        pos = $(this).offset();
        width = $(this).width();
        $helpDiv = $(HelpLinks.helpDivSelector($(this).data('field')));
        $helpDiv.css("left", "" + (pos.left - 600) + "px");
        $helpDiv.css("top", "" + pos.top + "px");
        return $helpDiv.show();
      });
      $('a.help').mouseout(function() {
        var $helpDiv;
        $helpDiv = $(HelpLinks.helpDivSelector($(this).data('field')));
        return $helpDiv.hide();
      });
      $('a.help').click(function(e) {
        return e.preventDefault();
      });
      return Forms.bind();
    });
  });

}).call(this);
