(function() {

  window.jQueryInWindow = function(func) {
    return func.call(window, jQuery);
  };

  if (top.location !== self.location) {
    top.location = self.location.href;
  }

  jQuery(function($) {
    $.fn.addDisableOverlay = function(supportedProducts) {
      var $disabledOverlay, $mainContent;
      $disabledOverlay = $('.body-disabled-overlay');
      $mainContent = $('.mainContent');
      $disabledOverlay.css({
        left: $mainContent.offset().left
      });
      $disabledOverlay.css({
        top: $mainContent.offset().top
      });
      $disabledOverlay.css({
        width: $mainContent.width()
      });
      if ($disabledOverlay.height() < $mainContent.height()) {
        $disabledOverlay.css({
          height: $mainContent.height() - 20
        });
      }
      $disabledOverlay.find('span.products').html("<a href='" + ($('span.registration-url').html()) + "'>register for the free " + supportedProducts + " trial</a>");
      return $disabledOverlay.removeClass('invisible');
    };
    $.fn.toggleVisibility = function($elem) {
      return $(this).live('click', function(e) {
        if ($(this).attr('checked')) {
          return $elem.show();
        } else {
          return $elem.hide();
        }
      });
    };
    $.fn.checkAll = function($elem) {
      var $checkboxes, setAllCheckboxState,
        _this = this;
      $checkboxes = $elem.find('input[type=checkbox]');
      setAllCheckboxState = function() {
        var $uncheckedCheckboxes;
        $uncheckedCheckboxes = $elem.find('input[type=checkbox]:not(:checked)');
        if ($uncheckedCheckboxes.length > 0) {
          return $(_this).removeAttr('checked');
        } else {
          return $(_this).attr('checked', 'checked');
        }
      };
      setAllCheckboxState();
      $(this).live('click', function(e) {
        if ($(this).attr('checked')) {
          return $checkboxes.attr('checked', 'checked');
        } else {
          return $checkboxes.removeAttr('checked');
        }
      });
      return $checkboxes.live('click', function(e) {
        return setAllCheckboxState();
      });
    };
    return $(document).ready(function() {
      var $topMenu;
      $topMenu = $('#top-menu li.menu ul.sub-menu').each(function(index, elem) {
        var parent_width;
        parent_width = $(elem).parent().outerWidth();
        if ($(elem).width() < parent_width) {
          return $(elem).width(parent_width + 10);
        }
      });
      return $('li#notification-menu').hover(function(e) {
        var $img;
        $img = $(this).find('img');
        return $img.attr('src', '/assets/icons/notification-badge-a356da5497a75a8ddf818d0ae239b799.png');
      });
    });
  });

  jQuery(function($) {

  jQuery.ajaxSetup({ 'beforeSend': function(xhr) {xhr.setRequestHeader("Accept", "text/javascript")} })

  function _ajax_request(url, data, callback, type, method) {
      if (jQuery.isFunction(data)) {
          callback = data;
          data = {};
      }
      return jQuery.ajax({
          type: method,
          url: url,
          data: data,
          success: callback,
          dataType: type
          });
  }

  jQuery.extend({
      put: function(url, data, callback, type) {
          return _ajax_request(url, data, callback, type, 'PUT');
      },
      delete_: function(url, data, callback, type) {
          return _ajax_request(url, data, callback, type, 'DELETE');
      }
  });

  /*
  Submit a form with Ajax
  Use the class ajaxForm in your form declaration
  form_for @comment,:html => {:class => "ajaxForm"} do |f|
  */
  jQuery.fn.submitWithAjax = function() {
    this.unbind('submit', false);
    this.submit(function() {
      $.post(this.action, $(this).serialize(), null, "script");
      return false;
    })

    return this;
  };

  /*
  Retreive a page with get
  Use the class get in your link declaration
  link_to 'My link', my_path(),:class => "get"
  */
  jQuery.fn.getWithAjax = function() {
    this.unbind('click', false);
    this.click(function() {
      $.get($(this).attr("href"), $(this).serialize(), null, "script");
      return false;
    })
    return this;
  };

  /*
  Post data via html
  Use the class post in your link declaration
  link_to 'My link', my_new_path(),:class => "post"
  */
  jQuery.fn.postWithAjax = function() {
    this.unbind('click', false);
    this.click(function() {
      $.post($(this).attr("href"), $(this).serialize(), null, "script");
      return false;
    })
    return this;
  };

  /*
  Update/Put data via html
  Use the class put in your link declaration
  link_to 'My link', my_update_path(data),:class => "put",:method => :put
  */
  jQuery.fn.putWithAjax = function() {
    this.unbind('click', false);
    this.click(function() {
      $.put($(this).attr("href"), $(this).serialize(), null, "script");
      return false;
    })
    return this;
  };

  /*
  Delete data
  Use the class delete in your link declaration
  link_to 'My link', my_destroy_path(data),:class => "delete",:method => :delete
  */
  jQuery.fn.deleteWithAjax = function() {
    this.removeAttr('onclick');
    this.unbind('click', false);
    this.click(function() {
      if(confirm("Are you sure you want to delete this vuln?")) {
        $.delete_($(this).attr("href"), $(this).serialize(), null, "script");
      }
      return false;
    })
    return this;
  };

  /*
  Ajaxify all the links on the page.
  This function is called when the page is loaded. You'll probaly need to call it again when you write render new datas that need to be ajaxyfied.'
  */
  function ajaxLinks(){
      $('.ajax-form').submitWithAjax();
      $('a.ajax-get').getWithAjax();
      $('a.ajax-post').postWithAjax();
      $('a.ajax-put').putWithAjax();
      $('a.ajax-delete').deleteWithAjax();
  }

  $(document).ready(function() {
  // All non-GET requests will add the authenticity token
   $(document).ajaxSend(function(event, request, settings) {
         if (typeof(window.AUTH_TOKEN) == "undefined") return;
         // IE6 fix for http://dev.jquery.com/ticket/3155
         if (settings.type == 'GET' || settings.type == 'get') return;

         settings.data = settings.data || "";
         settings.data += (settings.data ? "&" : "") + "authenticity_token=" + encodeURIComponent(window.AUTH_TOKEN);
       });

    ajaxLinks();
  });

});;


}).call(this);
