(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  jQueryInWindow(function($) {
    var QUICK_PENTEST_IS_FIRST_TASK_READY_URL, QUICK_PENTEST_REDIRECT_AFTER_SUCCESS_URL, QUICK_PENTEST_URL;
    QUICK_PENTEST_URL = '/quick_pentest';
    QUICK_PENTEST_IS_FIRST_TASK_READY_URL = '/quick_pentest/first_task_ready';
    QUICK_PENTEST_REDIRECT_AFTER_SUCCESS_URL = '/quick_pentest/redirect_after_success';
    return this.QuickPentestModal = (function(_super) {

      __extends(QuickPentestModal, _super);

      function QuickPentestModal() {
        this.formLoadedSuccessfully = __bind(this.formLoadedSuccessfully, this);

        this.pageAt = __bind(this.pageAt, this);

        this.handleErrors = __bind(this.handleErrors, this);

        this.someInputChanged = __bind(this.someInputChanged, this);

        this.resetErrorsOnTab = __bind(this.resetErrorsOnTab, this);

        this.resetErrors = __bind(this.resetErrors, this);

        this.startScanClicked = __bind(this.startScanClicked, this);

        this.reportTypeChanged = __bind(this.reportTypeChanged, this);

        this.scanTypeChanged = __bind(this.scanTypeChanged, this);

        this.toggleExcludeIPs = __bind(this.toggleExcludeIPs, this);

        this.toggleGenerateReport = __bind(this.toggleGenerateReport, this);

        this.toggleExploits = __bind(this.toggleExploits, this);

        this.toggleAdvanced = __bind(this.toggleAdvanced, this);
        return QuickPentestModal.__super__.constructor.apply(this, arguments);
      }

      QuickPentestModal.prototype.initialize = function() {
        QuickPentestModal.__super__.initialize.apply(this, arguments);
        this.setTitle('Quick Penetration Test');
        this.setDescription('Quickly set up a test that automatically gathers ' + 'information about the target network, launches attacks ' + 'against the targets, and builds a report of test findings.');
        this.setTabs([
          {
            name: 'Target Settings'
          }, {
            name: 'Configure Scan'
          }, {
            name: 'Run Exploits',
            checkbox: true
          }, {
            name: 'Generate Report',
            checkbox: true
          }
        ]);
        this.setButtons([
          {
            name: 'Cancel',
            "class": 'close'
          }, {
            name: 'Start Test',
            "class": 'btn primary'
          }
        ]);
        this.loadForm();
        return $("#modals").appendTo($('body'));
      };

      QuickPentestModal.prototype.showLoadingDialog = function() {
        this._loaderDialog = $('<div class="loading">').dialog({
          modal: true,
          closeOnEscape: false,
          title: 'Loading...'
        });
        this._loaderDialog.parents('.ui-dialog').addClass('white');
        return this._loaderDialog.append($('<p class="dialog-msg center">').text('Loading...'));
      };

      QuickPentestModal.prototype.hideLoadingDialog = function() {
        return this._loaderDialog.dialog('close').remove();
      };

      QuickPentestModal.prototype.setDialogTitle = function(title) {
        return $('.dialog-msg', this._loaderDialog).text(title);
      };

      QuickPentestModal.prototype.events = _.extend({
        'click a.advanced': 'toggleAdvanced',
        'click input#tab_run_exploits': 'toggleExploits',
        'click input#tab_generate_report': 'toggleGenerateReport',
        'click a.exclude_toggle': 'toggleExcludeIPs',
        'change input[name="quick_pentest[scan_type]"]': 'scanTypeChanged',
        'change select#quick_pentest_report_type': 'reportTypeChanged',
        'click .modal-actions .btn.primary': 'startScanClicked',
        'change select': 'someInputChanged',
        'change input, textarea': 'someInputChanged',
        'keydown input, textarea': 'someInputChanged'
      }, TabbedModalView.prototype.events);

      QuickPentestModal.prototype._steps = [];

      QuickPentestModal.prototype.loadForm = function() {
        _.each(this.tabs(), function(t) {
          return $(t).addClass('ui_disabled');
        });
        this.content().addClass('loading').html('');
        return $.ajax({
          url: QUICK_PENTEST_URL,
          method: 'get',
          success: this.formLoadedSuccessfully,
          error: function() {
            var _this = this;
            this.content().removeClass('loading').addClass('error').text("Unable to reach Metasploit Pro. Please ensure you" + " are connected and the Metasploit Pro service is running.");
            return _.delay((function() {
              return _this.content().is(':visible') && _this.loadForm();
            }), 5000);
          }
        });
      };

      QuickPentestModal.prototype.toggleAdvanced = function(e) {
        e.preventDefault();
        $(e.currentTarget).toggleClass('not_advanced');
        return $('~div.advanced', e.currentTarget).toggle();
      };

      QuickPentestModal.prototype.toggleExploits = function(e) {
        var checked;
        checked = $(e.currentTarget).is(':checked');
        $('h3.enabled>span', this.$modal).removeClass('disabled enabled');
        $('.configure_exploits h3.enabled>span', this.$modal).removeClass('disabled enabled');
        if (checked) {
          $('.configure_exploits h3.enabled>span', this.$modal).text("enabled").addClass('enabled');
          return $("[name='quick_pentest[exploit_enabled]']", this.$modal).attr('value', '1');
        } else {
          $('.configure_exploits h3.enabled>span', this.$modal).text("disabled").addClass('disabled');
          return $("[name='quick_pentest[exploit_enabled]']", this.$modal).removeAttr('value');
        }
      };

      QuickPentestModal.prototype.toggleGenerateReport = function(e) {
        var checked;
        checked = $(e.currentTarget).is(':checked');
        $('.generate_report h3.enabled>span', this.$modal).removeClass('disabled enabled');
        if (checked) {
          $('.generate_report h3.enabled>span', this.$modal).text("enabled").addClass('enabled');
          return $("[name='quick_pentest[report_enabled]']", this.$modal).attr('value', '1');
        } else {
          $('.generate_report h3.enabled>span', this.$modal).text("disabled").addClass('disabled');
          return $("[name='quick_pentest[report_enabled]']", this.$modal).removeAttr('value');
        }
      };

      QuickPentestModal.prototype.toggleExcludeIPs = function(e) {
        e.preventDefault();
        $('.excluded_addresses', this.$modal).show();
        $('.exclude_toggle_wrap', this.$modal).hide();
        return $('.create_project .advanced', this.$modal).css({
          top: '182px'
        });
      };

      QuickPentestModal.prototype.scanTypeChanged = function(e) {
        var toggle_divs;
        toggle_divs = ['toggle_regular_scan', 'toggle_nexpose_scan', 'toggle_import'];
        _.each(toggle_divs, function(div) {
          return $("." + div, this.$modal).hide();
        });
        return $(".toggle_" + ($(e.target).val()), this.$modal).show();
      };

      QuickPentestModal.prototype.reportTypeChanged = function(e) {
        var format;
        format = $('select#quick_pentest_report_type option:selected', this.$modal).val();
        $(".report_formats>div", this.$modal).hide().removeClass('active_report_option');
        $(".report_sections>div", this.$modal).hide().removeClass('active_report_option');
        $(".report_options>div", this.$modal).hide().removeClass('active_report_option');
        $(".report_formats #report_format_for_" + format, this.$modal).show().addClass('active_report_option');
        $(".report_sections #report_section_for_" + format, this.$modal).show().addClass('active_report_option');
        return $(".report_options #report_option_for_" + format, this.$modal).show().addClass('active_report_option');
      };

      QuickPentestModal.prototype.startScanClicked = function(e) {
        var $closeBtn, $form, $page, $primaryBtn,
          _this = this;
        e.preventDefault();
        this.resetErrors();
        $form = $('form', this.$modal).first();
        $('.hasErrors', this.$modal).hide();
        $page = $('div.content form .page').eq(this._tabIdx);
        this.showLoadingDialog();
        $primaryBtn = $('a.btn.primary', this.$modal).addClass('disabled');
        $closeBtn = $('.modal-actions a.close', this.$modal).addClass('ui-disabled');
        return this.submitFormAjax($form, {
          url: QUICK_PENTEST_URL,
          method: 'POST',
          error: function(e) {
            _this.hideLoadingDialog();
            $page.removeClass('page-loading');
            $primaryBtn.addClass('disabled');
            $closeBtn.removeClass('ui-disabled');
            return _this.handleErrors.apply(_this, arguments);
          },
          success: function(data) {
            var cancelMe, taskChainQuery;
            _this.setDialogTitle('Waiting for first task to start...');
            taskChainQuery = "?task_chain_id=" + data.task_chain_id;
            return cancelMe = window.setInterval((function() {
              return $.ajax({
                url: QUICK_PENTEST_IS_FIRST_TASK_READY_URL + taskChainQuery,
                dataType: 'json',
                success: function(data) {
                  if (data.success) {
                    window.clearInterval(cancelMe);
                    return window.location = QUICK_PENTEST_REDIRECT_AFTER_SUCCESS_URL + taskChainQuery;
                  }
                }
              });
            }), 3000);
          }
        });
      };

      QuickPentestModal.prototype.resetErrors = function(scope) {
        if (scope == null) {
          scope = this.$modal;
        }
        $('p.inline-error', scope).remove();
        return $('li.error', scope).removeClass('error');
      };

      QuickPentestModal.prototype.resetErrorsOnTab = function(tabIdx) {
        if (tabIdx == null) {
          tabIdx = this._tabIdx;
        }
        this.resetErrors($('form.quick_pentest>div.page', this.$el).eq(tabIdx));
        return this.tabAt(tabIdx).find('.hasErrors').hide();
      };

      QuickPentestModal.prototype.someInputChanged = function(e) {
        $('a.btn.primary', this.$modal).removeClass('disabled');
        return this._somethingHasChanged = true;
      };

      QuickPentestModal.prototype.handleErrors = function(errorsHash) {
        var modelsToTabs,
          _this = this;
        window.eh = errorsHash;
        $('.hasError', this.$modal).hide();
        modelsToTabs = {
          workspace: 0,
          "import": 1,
          scan_task: 1,
          nexpose_task: 1,
          exploit_task: 2,
          report_task: 3
        };
        return _.each(errorsHash.errors, function(modelErrors, modelName) {
          var $page, $tab, tabIdx;
          tabIdx = modelsToTabs[modelName];
          $page = _this.pageAt(tabIdx);
          if (typeof modelErrors === 'string' && $.trim(modelErrors).length > 0) {
            $tab = _this.tabAt(tabIdx);
            $tab.find('.hasErrors').show();
            $page.find('p.error-desc').remove();
            return $page.prepend($('<p>').addClass('error-desc').text(modelErrors));
          } else if (typeof modelErrors === 'object' && _.keys(modelErrors).length > 0) {
            $page.find('p.error-desc').remove();
            _this.tabAt(tabIdx).find('.hasErrors').show();
            return _.each(modelErrors, function(attrErrors, attrName) {
              var $li, inputName;
              inputName = "" + modelName + "[" + attrName + "]";
              $li = $("[name='" + inputName + "']", this.$modal).parents('li').first().addClass('error');
              return _.each(attrErrors, function(errorMsg) {
                return $("<p>").addClass('inline-error').appendTo($li).text(errorMsg);
              });
            });
          }
        });
      };

      QuickPentestModal.prototype.pageAt = function(idx) {
        return $('>form>.page', this.content()).eq(idx);
      };

      QuickPentestModal.prototype.formLoadedSuccessfully = function(html) {
        var _this = this;
        if (!this.content().is(':visible')) {
          return;
        }
        this.content().removeClass('loading').html(html);
        _.each(this.tabs(), function(t) {
          return $(t).removeClass('ui_disabled');
        });
        if ($("[name='quick_pentest[report_enabled]']", this.$modal).val()) {
          $("#tab_generate_report", this.$modal).attr('checked', true);
        }
        if ($("[name='quick_pentest[exploit_enabled]']", this.$modal).val()) {
          $("#tab_run_exploits", this.$modal).attr('checked', true);
        }
        $('form.quick_pentest>div.page', this.$el).hide().first().show();
        this.reportTypeChanged();
        $('#report_format_for_audit ol li label', this.$modal).removeAttr('for');
        this._steps = $.parseJSON($('meta[name=steps]', this.$modal).attr('content'));
        $('div.content form .page', this.$modal).each(function() {
          return $(this).append($('<div>').addClass('page-overlay'));
        });
        $('input:file', this.$modal).each(function() {
          var $label, $p, $span;
          $label = $(this).prev();
          $(this).attr('size', '50').css({
            overflow: 'hidden'
          });
          $p = $('<p>').text('Choose a file');
          $span = $('<span>').text($label.text());
          $label.html('').append($p).append($span);
          return $(this).change(function() {
            var path;
            path = $(this).val() || '';
            path = path.replace(/.*(\\|\/)/g, '');
            return $p.text(path);
          });
        });
        _.defer(this.layout);
        return _.defer(function() {
          return $('form :text:visible:first', _this.content()).focus();
        });
      };

      QuickPentestModal.prototype.index = function(idx) {
        var $allTabs, $currTab, $form, $li, $page, oldTabIdx,
          _this = this;
        $form = $('form.quick_pentest', this.$el);
        $allTabs = $('form.quick_pentest>div.page', this.$el);
        $currTab = $allTabs.eq(idx);
        this._somethingHasChanged = false;
        if (!(this._tabIdx < 0 || idx === this._tabIdx)) {
          oldTabIdx = this._tabIdx;
          this.resetErrorsOnTab(oldTabIdx);
          $li = $('ul.tabs>li', this.$modal).eq(this._tabIdx).addClass('tab-loading');
          $page = $('div.content form .page').eq(this._tabIdx).addClass('page-loading');
          $page.find('p.error-desc').remove();
          this.submitFormAjax($form, {
            noFiles: true,
            success: function() {
              $li.removeClass('tab-loading ui-disabled');
              $page.removeClass('page-loading');
              if (!($('.hasErrors:visible', _this.$modal).length > 0)) {
                return $('a.btn.primary', _this.$modal).removeClass('disabled');
              }
            },
            error: function() {
              $li.removeClass('tab-loading ui-disabled');
              $page.removeClass('page-loading');
              $('a.btn.primary', _this.$modal).addClass('disabled');
              return _this.handleErrors.apply(_this, arguments);
            }
          });
        }
        $allTabs.hide().eq(idx).show();
        return QuickPentestModal.__super__.index.apply(this, arguments);
      };

      QuickPentestModal.prototype.submitFormAjax = function($form, opts) {
        var data,
          _this = this;
        if (opts == null) {
          opts = {};
        }
        $('input[name=_method]', $form).not(':first').remove();
        $('input[name=_method]', $form).val(opts.method || 'PUT');
        $('input[name=no_files]', $form).val((opts.noFiles && '1') || '');
        data = $(':input', $form).not(':file').not('[type=checkbox]:not(:checked)').not(".report_formats>div:not(.active_report_option) *").not(".report_sections>div:not(.active_report_option) *").not(".report_options>div:not(.active_report_option) *");
        return $.ajax({
          url: opts['url'] || this._steps[this._tabIdx][1],
          type: 'POST',
          data: data.serializeArray(),
          processData: false,
          iframe: true,
          files: opts['noFiles'] ? $() : $(':file', $form),
          dataType: 'json',
          complete: function(resp) {
            try {
              data = $.parseJSON(resp.responseText);
            } catch (e) {
              alert('Error processing response from server. Please ensure Metasploit Pro is running.');
              return;
            }
            if (!data || !data['success']) {
              if (opts['error']) {
                return opts['error'].call(_this, data);
              }
            } else {
              if (opts['success']) {
                return opts['success'].call(_this, data);
              }
            }
          }
        });
      };

      return QuickPentestModal;

    })(this.TabbedModalView);
  });

}).call(this);
