(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  jQueryInWindow(function($) {
    return this.TabbedModalView = (function(_super) {

      __extends(TabbedModalView, _super);

      function TabbedModalView() {
        this.tabAt = __bind(this.tabAt, this);

        this.tabClicked = __bind(this.tabClicked, this);

        this.index = __bind(this.index, this);

        this.close = __bind(this.close, this);

        this.open = __bind(this.open, this);

        this.layout = __bind(this.layout, this);

        this.setMaxWidth = __bind(this.setMaxWidth, this);

        this.setTitle = __bind(this.setTitle, this);

        this.setDescription = __bind(this.setDescription, this);

        this.setButtons = __bind(this.setButtons, this);

        this.setTabs = __bind(this.setTabs, this);
        return TabbedModalView.__super__.constructor.apply(this, arguments);
      }

      TabbedModalView.prototype._tabIdx = -1;

      TabbedModalView.prototype._opened = false;

      TabbedModalView.prototype.initialize = function() {
        this.setMaxWidth(1000);
        return window.origConfirm || (window.origConfirm = window.confirm);
      };

      TabbedModalView.prototype.events = {
        'click a.close': 'close',
        'click ul.tabs>li': 'tabClicked'
      };

      TabbedModalView.prototype.setTabs = function(_tabs) {
        this._tabs = _tabs;
        return _.each(this._tabs, function(tab) {
          tab['class'] || (tab['class'] = '');
          return tab['checkbox'] || (tab['checkbox'] = false);
        });
      };

      TabbedModalView.prototype.setButtons = function(_btns) {
        this._btns = _btns;
        return _.each(this._btns, function(btn) {
          return btn['class'] || (btn['class'] = '');
        });
      };

      TabbedModalView.prototype.setDescription = function(description) {
        this.description = description;
      };

      TabbedModalView.prototype.setTitle = function(title) {
        this.title = title;
      };

      TabbedModalView.prototype.setMaxWidth = function(maxWidth) {
        this.maxWidth = maxWidth;
      };

      TabbedModalView.prototype.layout = function() {
        var modalWidth, screenWidth;
        if (this.$modal.width() > this.maxWidth) {
          this.$modal.width(this.maxWidth);
        }
        modalWidth = this.$modal.width();
        screenWidth = $(window).width();
        this.$modal.css('left', parseInt(($(window).width() - this.$modal.width()) / 2) + 'px');
        this.$modal.css('top', parseInt(($(window).height() - this.$modal.height()) / 2) + 'px');
        return $('ul.tabs>li:first-child', this.el).addClass('first-child');
      };

      TabbedModalView.prototype.template = _.template($('#tabbed-modal').html());

      TabbedModalView.prototype.open = function() {
        this.render();
        this._opened = true;
        this.escEnabled = true;
        $('body').css({
          overflow: 'hidden'
        }).height($(window).height());
        $(window).unbind('resize.tabbedModal');
        $(window).unbind('keyup.tabbedModal');
        $(window).bind('resize.tabbedModal', this.layout);
        $(window).bind('keyup.tabbedModal', this.escKeyHandler);
        return this.stubCustomConfirm();
      };

      TabbedModalView.escKeyHandler = function(e) {
        if (e.keyCode === 27 && TabbedModalView.escEnabled) {
          return TabbedModalView.close();
        }
      };

      TabbedModalView.prototype.close = function(e) {
        if (e && e.preventHandler) {
          e.preventHandler();
        }
        this.$el.html('');
        this._opened = false;
        this.escEnabled = false;
        $('body').css({
          overflow: 'auto'
        }).css({
          height: 'auto',
          overflow: 'inherit'
        });
        $(window).unbind('resize.tabbedModal');
        $(window).unbind('keyup.tabbedModal');
        window.confirm = window.origConfirm;
        return this.undelegateEvents();
      };

      TabbedModalView.prototype.stubCustomConfirm = function() {
        var _this = this;
        return window.confirm = function() {
          if (_this.opened) {
            _this.escEnabled = false;
            _.delay((function() {
              return _this.escEnabled = true;
            }), 300);
            return origConfirm.apply(window, arguments);
          } else {
            return origConfirm.apply(window, arguments);
          }
        };
      };

      TabbedModalView.prototype.index = function(idx) {
        var $li, $ul;
        if (typeof idx === 'undefined') {
          return this._tabIdx;
        }
        if (idx === this._tabIdx || idx < 0 || idx >= this._tabs.length) {
          return this._tabIdx;
        }
        $ul = $('ul.tabs', this.el);
        $li = $('li', $ul).removeClass('selected').eq(idx).addClass('selected');
        $('div.content', this.el).toggleClass('top-left-square', idx === 0);
        this._tabIdx = idx;
        return this._tabIdx;
      };

      TabbedModalView.prototype.tabClicked = function(e) {
        var $li;
        $li = $(e.currentTarget);
        return this.index($li.index());
      };

      TabbedModalView.prototype.tabAt = function(idx) {
        return $('ul.tabs li', this.$modal).eq(idx);
      };

      TabbedModalView.prototype.render = function() {
        TabbedModalView.__super__.render.apply(this, arguments);
        this.$el.html(this.template(this));
        this.$modal = $('.tabbed-modal', this.$el);
        this.layout();
        if (this._tabIdx < 0) {
          return this.index(0);
        }
      };

      TabbedModalView.prototype.tabs = function() {
        return $('ul.tabs>li', this.$modal);
      };

      TabbedModalView.prototype.content = function() {
        return $('.padding>.content', this.$modal);
      };

      return TabbedModalView;

    }).call(this, Backbone.View);
  });

}).call(this);
