(function() {

  jQuery(function($) {
    return $(function() {
      return $(document).ready(function() {
        var $log, task, updateLog;
        $log = $('#task_logs');
        task = $log.attr('task');
        window.log = $log;
        $log.bind('scrollToBottom', function() {
          return $(this).scrollTop($(this).attr('scrollHeight'));
        });
        $log.bind('addLine', function(event, html) {
          var innerHeight, padding, prevLine, scrolled, shouldScrollToBottom;
          prevLine = $(this).data('prevLine');
          padding = parseInt($(this).css('padding-top')) + parseInt($(this).css('padding-bottom'));
          innerHeight = $(this).attr('scrollHeight') - padding;
          scrolled = $(this).height() + $(this).scrollTop();
          shouldScrollToBottom = scrolled >= innerHeight;
          if (html !== prevLine) {
            $(this).append(html);
          }
          if (shouldScrollToBottom) {
            $(this).trigger('scrollToBottom');
          }
          return $(this).data('prevLine', html);
        });
        updateLog = function() {
          var lines;
          if ($('#task_logs .end').length === 0) {
            lines = $log.children().length;
            return $.getJSON('/tasks/' + task + '/logs?line=' + lines, function(data) {
              var header, log;
              log = data['log'];
              header = data['header'];
              if (log && log.length > 0) {
                $('#task_logs').trigger('addLine', log);
              }
              if (header && header.length > 0) {
                $('#taskDetails').html(header);
              }
              return window.setTimeout(updateLog, 3000);
            });
          }
        };
        $log.trigger('scrollToBottom');
        return updateLog();
      });
    });
  });

}).call(this);
