(function() {

  jQuery(function($) {
    return $(function() {
      var $vulnsDataTable, $vulnsTable, vulnsPath;
      vulnsPath = $('#vulns-path').html();
      $vulnsTable = $('#vulns-table');
      $vulnsDataTable = $vulnsTable.table({
        analysisTab: true,
        searchInputHint: "Search Vulnerabilities",
        datatableOptions: {
          "oLanguage": {
            "sEmptyTable": "No vulnerabilities are associated with this Project."
          },
          "sAjaxSource": vulnsPath,
          "aaSorting": [[4, 'asc'], [2, 'asc']],
          "aoColumns": [
            {
              "mDataProp": "checkbox",
              "bSortable": false
            }, {
              "mDataProp": "host",
              "sWidth": "200px"
            }, {
              "mDataProp": "service",
              "sWidth": "60px",
              "bSortable": false
            }, {
              "mDataProp": "name",
              "sWidth": "400px"
            }, {
              "mDataProp": "exploits",
              "sWidth": "22px"
            }, {
              "mDataProp": "refs",
              "bSortable": false
            }
          ]
        }
      });
      $('a.full-ref-map-view').live('click', function(e) {
        var $dialog;
        $dialog = $("<div style='display:hidden'>" + ($(this).closest('table').siblings('.full-ref-map').html()) + "</div>").appendTo('body');
        $dialog.dialog({
          title: "References",
          width: 600,
          maxHeight: 500,
          buttons: {
            "Close": function() {
              return $(this).dialog('close');
            }
          }
        });
        return e.preventDefault();
      });
      return $vulnsTable.addCollapsibleSearch();
    });
  });

}).call(this);
