(function() {

  jQuery(function($) {
    return $(document).ready(function() {
      var bindRichTextButton, cloneSite, editor, toggleFullscreenEditing,
        _this = this;
      editor = CodeMirror.fromTextArea(document.getElementById("web_template_body"), {
        lineNumbers: true,
        onKeyEvent: function(i, e) {
          if ((e.keyCode === 122 || e.keyCode === 27) && e.type === 'keydown') {
            e.stop();
            return toggleFullscreenEditing();
          }
        }
      });
      bindRichTextButton = function($button, tag) {
        return $button.click(function() {
          editor.replaceSelection("<" + tag + ">" + (editor.getSelection()) + "</" + tag + ">");
          return editor.focus();
        });
      };
      bindRichTextButton($('.rich-text-control-bar').find('.bold'), 'strong');
      bindRichTextButton($('.rich-text-control-bar').find('.italic'), 'em');
      bindRichTextButton($('.rich-text-control-bar').find('.underline'), 'u');
      bindRichTextButton($('.rich-text-control-bar').find('.strikeout'), 's');
      bindRichTextButton($('.rich-text-control-bar').find('.code'), 'code');
      bindRichTextButton($('.rich-text-control-bar').find('.pre'), 'pre');
      bindRichTextButton($('.rich-text-control-bar').find('.h1'), 'h1');
      bindRichTextButton($('.rich-text-control-bar').find('.h2'), 'h2');
      bindRichTextButton($('.rich-text-control-bar').find('.h3'), 'h3');
      $('.rich-text-control-bar').find('.prev').click(function() {
        var $form, $methodInput, newBody, oldAction, oldBody, oldMethod;
        $form = $('form.web_template');
        $methodInput = $('input[name=_method]');
        oldAction = $form.attr('action');
        oldMethod = $methodInput.val();
        oldBody = editor.getValue();
        newBody = oldBody.split('').reverse().join('');
        editor.setValue(newBody);
        $form.attr('action', $('.rich-text-control-bar').find('span.hidden').html());
        $form.attr('target', '_web_template');
        $methodInput.val('post');
        $form.submit();
        $form.attr('action', oldAction);
        $form.attr('target', '');
        editor.setValue(oldBody);
        return $methodInput.val(oldMethod);
      });
      toggleFullscreenEditing = function() {
        var editorDiv;
        editorDiv = $('.CodeMirror-scroll');
        if (!editorDiv.hasClass('fullscreen')) {
          toggleFullscreenEditing.beforeFullscreen = {
            height: editorDiv.height(),
            width: editorDiv.width()
          };
          editorDiv.addClass('fullscreen');
          editorDiv.height('100%');
          editorDiv.width('100%');
          return editor.refresh();
        } else {
          editorDiv.removeClass('fullscreen');
          editorDiv.height(toggleFullscreenEditing.beforeFullscreen.height);
          editorDiv.width(toggleFullscreenEditing.beforeFullscreen.width);
          return editor.refresh();
        }
      };
      cloneSite = function(clonePath) {
        var $cloneButton;
        $cloneButton = $('#clone-website');
        $cloneButton.addClass('submitting');
        return $.post($cloneButton.attr('href'), {
          clone_url: $('#clone_url').val()
        }, function(data) {
          editor.setValue(data);
          return $cloneButton.removeClass('submitting');
        });
      };
      $('#clone-website').click(function(e) {
        cloneSite();
        return e.preventDefault();
      });
      $('#web_template_exploit_name').chosen();
      $('#web_template_exploit_name').change(function() {
        $('#module_fields').css({
          opacity: 0.3
        });
        return $.post($('#exploit_options_url').val(), {
          module_name: $(this).val()
        }, function(data) {
          $('#module_fields').html(data);
          return $('#module_fields').css({
            opacity: 1
          });
        });
      });
      $('#clone_url').focus(function() {
        if (!$(this).val()) {
          return $(this).val('http://');
        }
      });
      return $('#clone_url').keypress(function(e) {
        if (e.which === 13) {
          cloneSite();
          return e.preventDefault();
        }
      });
    });
  });

}).call(this);
