(function() {

  _.templateSettings = {
    evaluate: /\{%([\s\S]+?)%\}/g,
    escape: /\{\{([\s\S]+?)\}\}/g
  };

  jQuery(function($) {
    var toggleNewsPane;
    toggleNewsPane = function(e) {
      var $a;
      $a = $(e.target).unbind('click');
      Effect.toggle('product-news', 'blind', {
        duration: 0.2
      });
      if (document.getElementById('project-list').style.width === "60%") {
        $a.html($a.html().replace('Hide', 'Show'));
        $('#project-list').css('width', '100%');
        document.cookie = 'ui-workspace-index-hide-product-news=false';
      } else {
        $a.html($a.html().replace('Show', 'Hide'));
        $('#project-list').css('width', '60%');
        document.cookie = 'ui-workspace-index-hide-product-news=true';
      }
      window.setTimeout((function() {
        return $a.bind('click', toggleNewsPane);
      }), 300);
      return false;
    };
    return $(document).ready(function() {
      var currTitle, feedTs, feedVersion, newsHidden, pid, script;
      $("#all_workspaces").checkAll($("#workspace_checkboxes"));
      script = document.createElement("script");
      pid = encodeURIComponent($('meta[name=msp-feed-serial]').attr('content'));
      feedVersion = encodeURIComponent($('meta[name=msp-feed-serial]').attr('content'));
      feedTs = encodeURIComponent($('meta[name=msp-feed-serial]').attr('content'));
      script.setAttribute("src", "https://dev.metasploit.com/news.js?pid=" + pid + "&ver=" + feedVersion + "&ts=" + feedTs);
      $(script).load(function() {
        var buildFeedItem, item, _i, _len, _ref, _results;
        buildFeedItem = function(item) {
          var content;
          content = "<div class='feeditem'><h3><a href='" + item.link + "' target='_blank'>" + item.title + "</a></h3><p class='blurb'>" + item.blurb + "</p></div>";
          return $("#product-news-content").append(content);
        };
        if (!window.NEWSFEED || window.NEWSFEED.feed.items.length === 0) {
          return $("#product-news-content").html('Unable to retrieve the product news from the server.');
        } else {
          $("#product-news-content").html('');
          _ref = NEWSFEED.feed.items;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            item = _ref[_i];
            _results.push(buildFeedItem(item));
          }
          return _results;
        }
      });
      document.body.appendChild(script);
      newsHidden = document.cookie.match(/ui-workspace-index-hide-product-news=false/);
      currTitle = newsHidden ? 'Show News Panel' : 'Hide News Panel';
      $('#crumbHolder').append('<a style="float: right; background-image:none;' + ' padding-right: 16px; cursor: pointer;" class="showhide"' + ' href="#">' + currTitle + '</a>');
      $('#crumbHolder a.showhide').prepend('<img alt="Newspaper" ' + ' src="/assets/icons/silky/newspaper.png" style="margin-bottom: -3px; ' + ' margin-right: 3px;">').click(toggleNewsPane);
      $("#workspace-table").table({
        searchable: false,
        datatableOptions: {
          "aaSorting": [[7, 'desc']],
          "aoColumns": [
            {
              "bSortable": false
            }, {}, {}, {}, {}, {}, {}, {
              "sType": "title-numeric"
            }, {}
          ]
        }
      });
      $('#search').inputHint({
        fadeOutSpeed: 300,
        padding: '2px',
        paddingLeft: '5px'
      });
      if (newsHidden) {
        $("#product-news").hide();
        return $('#project-list').css('width', '100%');
      } else {
        $("#product-news").show();
        return $('#project-list').css('width', '60%');
      }
    });
  });

}).call(this);
