#!/usr/bin/env ruby
#
# $Id$

root = File.expand_path(File.join(__FILE__, "..", "..", ".."))

# Assume it's in the path
zip = "7za"
outfile = "diagnostics-" + Time.now.strftime("%Y%m%d%H%M") + ".zip"

logs = [
	File.join(root, "engine", "config", "logs", "framework.log"),
	File.join(root, "engine", "config", "logs", "db.log"),
	File.join(root, "engine", "prosvc.log"),
	File.join(root, "engine", "prosvc_stderr.log"),
	File.join(root, "engine", "prosvc_stdout.log"),
	File.join(root, "ui", "log", "production.log"),
	File.join(root, "ui", "log", "thin.log"),
	File.join(root, "tasks"),
	File.join(root, "engine", "license"),
	File.join(root, "engine", "revision.txt"),
	File.join(root, "engine", "license.log"),
	File.join(root, "log", "install"),
]


hide = " >/dev/null 2>&1"
if RUBY_PLATFORM =~ /mingw32/
	hide = "1>NUL 2>NUL"
elsif Process.euid != 0
	$stdout.puts("[-] This script needs root permissions.  Please run again as root")
	exit(1)
end

$stdout.puts %Q|

**************************************
*                                    *
*     Metasploit Diagnostic Logs     *
*                                    *
**************************************

[*] Make sure to shut down all Metasploit before running this script!!
[*] Creating archive of diagnostic logs...

|


args = logs.collect {|l| "\"#{l}\""}.join(" ")

system("#{zip} a #{outfile} #{args} #{hide}")

if (not File.exist? outfile)
	$stdout.puts "[-] Unable to create zip file.  Has the installation been corrupted?\n\n"
else
	$stdout.puts "[*] Created #{outfile} (#{File.size(outfile)} bytes)\n\n"
end

