#!/usr/bin/env ruby

def get_thin_port(base)
	res = 3001
	cnf = File.join(base, "apps", "pro", "ui", "conf", "metasploit.conf")
	return res if not File.exist?(cnf)
	dat = File.read(cnf)
	if dat =~ /BalancerMember\s+http:\/\/127.0.0.1:(\d+)/
		res = $1.to_i
	end
	res
end

def get_thin_pid(base)
	res = nil
	pid = File.join(base, "apps", "pro", "ui", "log", "thin.pid")
	return if not ::File.exist?(pid)
	::File.read(pid).to_i
end

def get_thin_cmd(base, port, cmd)
	"su - daemon -s /bin/sh -c \". #{base}/scripts/setenv.sh && cd #{base}/apps/pro/ui && umask 077 && " +
	"ruby #{base}/ruby/bin/thin #{cmd} -e production -p #{port} -a 127.0.0.1 -l log/thin.log -P log/thin.pid -d\""
end

# Get our bearings
@cwd = File.dirname(__FILE__)
@pro = File.expand_path(File.join(@cwd, "..", "..", "..", ".."))
@prt = get_thin_port(@pro)
@pid = get_thin_pid(@pro)

# Parse arguments
@act = ARGV.shift

case @act
when "start"
	system( get_thin_cmd(@pro, @prt, "start") )
	puts "metasploit is running"
when "stop"
	if @pid
		::Process.kill(9, @pid) rescue nil
	end
	system("pkill -9 -f thin")
	puts "metasploit is stopped"
when "status"
	if @pid
		if (::Process.kill(0, @pid).to_i rescue 0) == 1
			puts "metasploit is running"
		else
			puts "metasploit is stopped"
		end
	else
		puts "metasploit is stopped"
	end
else
	exit(0)
end
